webpackJsonp([20],[
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var React = __webpack_require__(2);
	var ReactDOM = __webpack_require__(159);

	var KmsApi = __webpack_require__(178);
	var KmcDateFunction = __webpack_require__(319);
	var KmcStatusBar = __webpack_require__(252);
	var KmcContainer = __webpack_require__(237);
	var KmcSuperTable = __webpack_require__(239);
	var KmcAlertDialog = __webpack_require__(257);
	var KmcDividerZoom = __webpack_require__(344);
	var FastClick = __webpack_require__(231);
	var sortDesc = __webpack_require__(349).sortDesc;

	__webpack_require__(160);
	__webpack_require__(333);

	var context = null;
	window.handlePageBack = function () {
	    if (context != null) {
	        context.refs.container.refresh();
	    }
	};

	var KCDWTCX = React.createClass({
	    displayName: 'KCDWTCX',

	    //当前选中的项的值
	    selectData: null,

	    //点击回调
	    onClickRow: function onClickRow(row) {
	        this.selectData = row;

	        // 保存点击的表格行记录数据
	        var order = [["证券代码:", row.zqdm], ["证券名称:", row.zqmc], ["委托价格:", row.wtjg], ["委托数量:", row.wtsl]];
	        this.refs.alert.setState({ show: true, content: order });
	    },

	    handleOK: function handleOK() {
	        var self = this;
	        this.refs.alert.setState({ show: false });
	        KmsApi.call("trade", "ptjy/gfzr/wtcd", {
	            jysdm: this.selectData.jysdm,
	            gddm: this.selectData.gddm,
	            wtxh: this.selectData.wtxh
	        }, function (response) {
	            if (response.htxx && response.htxx.length > 0) {
	                var tips = "委托提交成功，流水号：" + response.htxx[0].wtxh;
	                self.refs.notice.setState({ show: true, content: [tips] });
	            }
	        });
	    },

	    handleNoticeOK: function handleNoticeOK() {
	        this.refs.notice.setState({ show: false });
	        this.refs.container.refresh();
	    },
	    componentDidMount: function componentDidMount() {
	        context = this;
	        FastClick.attach(document.body);
	    },
	    // 使用 render() 方法生成真实 DOM 并插入到网页中
	    render: function render() {

	        return React.createElement(
	            'div',
	            null,
	            this.getTable()
	        );
	    },

	    getTable: function getTable() {
	        var Table = KmcSuperTable.Controls.Table;
	        var Column = KmcSuperTable.Controls.Column;
	        var EmptyHint = KmcSuperTable.Controls.EmptyHint;
	        var Container = KmcContainer.Controls.Container;

	        var getRowColorKind = function getRowColorKind(row) {
	            return row.mmlb == 'S' ? 'color-kind mm sale' : row.mmlb == 'B' ? 'color-kind mm buy' : 'color-kind default';
	        };

	        var superTable = React.createElement(
	            Table,
	            { name: 'superTable', dock: true, onClickRow: this.onClickRow },
	            React.createElement(Column, { title: '名称/时间', width: '24.5%', fields: ['zqmc', 'wtsj'] }),
	            React.createElement(Column, { title: '方向/状态', width: '25.5%', fields: ['mmlbsm', "wtztsm"] }),
	            React.createElement(Column, { title: '委托价格', width: '25.2%', fields: ['wtjg'] }),
	            React.createElement(Column, { title: '委托/成交', width: '24.8%', fields: ['wtsl', "cjsl"] }),
	            React.createElement(EmptyHint, { text: '暂无可撤单记录哦~', img: '../../../img/gfzr_icon_empty.png' })
	        );

	        var param = {
	            requireBind: {
	                api: 'ptjy/gfzr/kcdwtcx',
	                requirePara: {
	                    cxfx: "1",
	                    qqhs: "1000"

	                },
	                responsePara: 'cxlb',
	                componentShow: 'superTable'
	            },
	            bars: ["dividerZoom"],
	            reverseResult: true,
	            formatMethod: function formatMethod(datas) {
	                datas = sortDesc(datas, ["wtrq", "wtsj"]);
	                for (var i = 0; i < datas.length; i++) {
	                    datas[i].wtsj = datas[i].wtsj.changeTimeToLocalFormat();
	                }
	            }
	        };

	        return React.createElement(
	            'div',
	            null,
	            React.createElement(
	                Container,
	                _extends({ ref: 'container' }, param),
	                React.createElement(KmcDividerZoom, { name: 'dividerZoom' }),
	                superTable
	            ),
	            React.createElement(KmcAlertDialog, {
	                ref: 'alert',
	                title: '撤单确认',
	                okText: '确定',
	                onOK: this.handleOK,
	                isNewUI: true }),
	            React.createElement(KmcAlertDialog, {
	                ref: 'notice',
	                title: '温馨提示',
	                okText: '确定',
	                cancelText: '',
	                centerShow: true,
	                onOK: this.handleNoticeOK,
	                isNewUI: true })
	        );
	    }
	});

	ReactDOM.render(React.createElement(KCDWTCX, null), document.getElementById('gfzr-wtcd'));

/***/ })
]);