webpackJsonp([24],[
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';

	__webpack_require__(160);
	var React = __webpack_require__(2);
	var ReactDOM = __webpack_require__(159);

	var KmcTab = __webpack_require__(300);
	var KmcDateFunction = __webpack_require__(319);
	var KmcContainer = __webpack_require__(237);
	var KmcSuperTable = __webpack_require__(239);
	var KmcLocalStorageFunction = __webpack_require__(174);

	var WTCJCX = React.createClass({
	    displayName: 'WTCJCX',

	    selectionIndex: 0, //当前选中时间段
	    peroid: KmcDateFunction.getStartEndPeroid(0), // 请求时间段
	    yhdms: [], //银行代码集合
	    hbdms: [], //货币代码集合

	    getInitialState: function getInitialState() {
	        return {
	            url: 'ggqq/yqzz/dryqzzlscx',
	            emptyHint: '您今天没有流水记录',
	            param: { cxfx: "1" }
	        };
	    },

	    componentWillUpdate: function componentWillUpdate() {
	        var backData = KmcLocalStorageFunction.getLocalData("ggqq-yqzz-bank-list");
	        if (backData) {
	            var yhdmDic = backData.yhdm;
	            var key;
	            for (key in yhdmDic) {
	                this.yhdms.push(key);
	            }
	            var hbdmDic = backData.hbdm;
	            for (key in hbdmDic) {
	                this.hbdms.push(key);
	            }
	        }
	    },

	    /*================================================================
	     函数功能: 点击"当日","一个月内","半年内"标签页响应函数
	     @ index ---- 点击的标签页序号
	     ================================================================*/
	    handlePageTabClick: function handlePageTabClick(index) {
	        this.selectionIndex = index;
	        this.refrshView();
	    },

	    refrshView: function refrshView() {
	        var date;
	        switch (this.selectionIndex) {
	            case 0:
	                {
	                    //当日
	                    this.setState({
	                        emptyHint: '您今天没有流水记录',
	                        url: 'ggqq/yqzz/dryqzzlscx',
	                        param: {}
	                    });
	                }
	                break;
	            case 1:
	                {
	                    //1个月内
	                    date = KmcDateFunction.getStartEndPeroid(-1);
	                    this.setState({
	                        emptyHint: '您这个月没有流水记录',
	                        url: 'ggqq/yqzz/lsyqzzlscx',
	                        param: { ksrq: date.qsrq, jsrq: date.zzrq }
	                    });
	                }
	                break;
	            case 2:
	                {
	                    //半年内
	                    date = KmcDateFunction.getStartEndPeroid(-6);
	                    this.setState({
	                        emptyHint: '您半年内没有流水记录',
	                        url: 'ggqq/yqzz/lsyqzzlscx',
	                        param: { ksrq: date.qsrq, jsrq: date.zzrq }
	                    });
	                }
	                break;
	        }
	    },

	    render: function render() {
	        var datetab = ["当日", "一个月内", "半年"];
	        var tableData = [{ key: "转账时间", value: ["fsrq"] }, { key: "业务/状态", value: ["ywbzsm", "ywztsm"] }, { key: "金额/币种", value: ["ywje", "hbmc"] }, { key: "资金账号", value: ["zjzh", "yhmc"] }];

	        var Table = KmcSuperTable.Controls.Table;
	        var Column = KmcSuperTable.Controls.Column;
	        var EmptyHint = KmcSuperTable.Controls.EmptyHint;
	        var Container = KmcContainer.Controls.Container;
	        var getRowColorKind = function getRowColorKind(row) {
	            return row.mmlb == 'S' ? 'color-kind mm sale' : row.mmlb == 'B' ? 'color-kind mm buy' : 'color-kind default';
	        };

	        var attrs = ["fsrq", "fssj", "ywbz", "ywzt", "ywje", "hbdm", "hbmc", "zjzh", "yhmc"];
	        var param = {
	            requireBind: {
	                isGGQQ: true,
	                api: this.state.url,
	                requirePara: this.state.param,
	                responsePara: 'cxlb',
	                componentShow: 'superTable'
	            },
	            reverseResult: this.selectionIndex === 0 ? true : false,
	            emptyHint: this.state.emptyHint,
	            bars: ['tab'],
	            formatMethod: function formatMethod(datas) {
	                var data, attName;
	                var simbol = "--";
	                for (var i = 0, dLen = datas.length; i < dLen; i++) {
	                    data = datas[i];
	                    for (var j = 0, len = attrs.length; j < len; j++) {
	                        attName = attrs[j];
	                        if (!data[attName]) {
	                            data[attName] = simbol;
	                        }
	                    }
	                    data.fsrq = data.fsrq != simbol ? data.fsrq.changeServerToLocalFormat() : simbol;
	                    data.fssj = data.fssj != simbol ? data.fssj.changeTimeToLocalFormat() : simbol;
	                }
	            }
	        };

	        return React.createElement(
	            Container,
	            param,
	            React.createElement(KmcTab, { name: 'tab', pagetab: datetab, pagetabClick: this.handlePageTabClick }),
	            React.createElement(
	                Table,
	                { name: 'superTable', getRowColorKind: getRowColorKind },
	                React.createElement(Column, { title: tableData[0].key, width: '20%', fields: tableData[0].value }),
	                React.createElement(Column, { title: tableData[1].key, width: '20%', fields: tableData[1].value }),
	                React.createElement(Column, { title: tableData[2].key, width: '30%', fields: tableData[2].value }),
	                React.createElement(Column, { title: tableData[3].key, width: '30%', fields: tableData[3].value }),
	                React.createElement(EmptyHint, { text: '您今天没有委托成交的记录' })
	            )
	        );
	    }

	});

	ReactDOM.render(React.createElement(WTCJCX, null), document.getElementById('ggqq-zjls'));

/***/ })
]);