/**
 *
 * $Date: 2015-07-18 11:32:48 +0800 (周六, 2015-07-18) $
 * $Revision: 4867 $
 * $Author: wangpenghui $
 */

var kmmsl = {
  wtdw: "", //委托单位
  mmsl: "", //买卖数量
  gfkys: "", //股份可用数
  minNum: "", // 仓位可接受的最小数量
  isKCB: false, // 是否为科创板股票
};

var kmmslcxlist = {
  market: "", //最新价 涨跌停价
  prices: "" //五档价格
};

var curTime = {

  hh: "", // 当前小时
  mm: "", // 当前分钟
  hhmm: "", // 当前小时分钟
  myDate: "", // 当前时间对象
  isTradeStage: false // 交易时段标志位
};

// ajax请求是否完成
var AJAX_FINISH = true;

// 0-深A  1-沪A  2-深B  3-沪B  4-三板A  5-三板B
var SZA = [];
var SZB = [];
var SHA = [];
var SHB = [];
var SBA = [];
var SBB = [];

// 主股东账号
var mainGDZH = {
  "SZA": "",
  "SZB": "",
  "SHA": "",
  "SHB": "",
  "SBA": "",
  "SBB": ""
};

/*=============================================================
函数功能：               可买卖数量查询
传入参数:  scope:angularJS作用域   response:服务器返回数据
=============================================================*/
function KMMSLQuery(scope, response) {

  // 如果证券代码为空,清除查询内容
  if ($("#zqdm").val().length == 0) {
    clearBargainPageFullData("hasAjax");
    return;
  }
  var marketlist = response.kmmxx[0];
  // 如果是科创板的股票，则最小数量为200
  if (marketlist.zqlb === 'w') {
    kmmsl.minNum = 200;
    kmmsl.isKCB = true;
  } else {
    kmmsl.minNum = "";
    kmmsl.isKCB = false;
  }
  // 查询股票如果停牌,终止自动查询
  if (marketlist.tpbz == "1") {
    order.isStopAutoQuery = true;
    showAlert("该股票已经停牌", "提示信息");
  }

  //为限价委托时默认显示服务器传来的wtjg字段,后面为用户自己填写的价格
  if(order.isFirstInputPrice && $("#consign .consign-type").text() == "限价委托"){
    $("#price").val(marketlist.wtjg);
  }

  // 现券还券解析内容较少,所以单独进行处理
  if ($("#HuanQuanType button.active").text() == "现券还券") {
    fullHQSL(response);
    return;
  }

  // 显示五档行情刷新按钮
  if ($("#refresh-page").css("display") == "none") {
    $("#refresh-page").show();
  }

  //=========解析交易所代码==================
  order.curjysdm = marketlist.jysdm;
  order.curzqlb = marketlist.zqlb;
  //=========如果交易所代码不一样,重新初始化股东代码列表======
  if ((order.curjysdm != order.lastjysdm) || (order.curzqlb != order.lastzqlb)) {
    //=======更新交易所代码历史值==========
    order.lastjysdm = order.curjysdm;
    order.lastzqlb = order.curzqlb;
    //===========解析股东列表==================
    parseHolderList(marketlist.jysdm, marketlist.zqlb);
  } else {
    //切换代码后，操作了一次清空股东代码，故同一个市场代码需重新取值
    order.curgddm = marketlist.gddm;
  }

  //==============解析委托单位===============
  marketlist.wtdw = kmmsl.wtdw = marketlist.wtdw ? marketlist.wtdw : "股";

  if ($("#HuanQuanType button.active").text() == "买券还券") {

    var kmqhqsl = marketlist.kmqhqsl ? marketlist.kmqhqsl : 0;
    $("#rzrq-hqsl").text(parseInt(kmqhqsl) + marketlist.wtdw);

  }

  // 债券逆回购虽为卖出,但委托数量取的是可买卖数量
  if (
    (marketlist.zqdm >= "131800" && marketlist.zqdm <= "131899") || // 深圳 债券回购
    (marketlist.zqdm >= "201000" && marketlist.zqdm <= "204999") // 上海 债券回购
  ) {
    order.gznhg = true;
  } else {
    order.gznhg = false;
  }

  order.sfjjts = marketlist.sfjjts;

  // 服务器返回的可买卖数量字段名称有时为kmmsl,有时为kmsl,哪个字段名称存在,
  // 可买卖数量就取哪个字段名称
  if (marketlist.kmmsl) {
    kmmsl.mmsl = marketlist.kmmsl ? marketlist.kmmsl : 0;
  } else if (marketlist.kmsl) {
    kmmsl.mmsl = marketlist.kmsl ? marketlist.kmsl : 0;
  } else {
    kmmsl.mmsl = 0;
  }

  if (order.gznhg) {
    marketlist.wtdw = "张";
  }

  //===================解析可买卖数量=============================
  if (getLocalData("page") == "融券卖出") {
    var kmmslplaceholder = "可卖出" + parseInt(kmmsl.mmsl) + marketlist.wtdw;
  } else if (order.mmlb == "B") {
    var kmmslplaceholder = "可买入" + parseInt(kmmsl.mmsl) + marketlist.wtdw;
  } else if (order.mmlb == "S") {
    kmmsl.gfkys = marketlist.gfkys ? marketlist.gfkys : 0;
    var kmmslplaceholder = "可卖出" + parseInt(kmmsl.gfkys) + marketlist.wtdw;
  }

  $("#volume").attr({
    "placeholder": kmmslplaceholder
  });

  // 如果证券代码为空,则自动填充证券代码
  // if( $("#zqmc").text().length == 0 )
  // {
  //   // 股票代码输入框的初始宽度为100%,太小的话输入证券代码提示语会显示不全
  //   // 当要同时显示股票代码和名称时,为了给股票名称留出显示位置
  //   // 需要重新设置股票代码输入框的宽度
  //   $("#zqdm").val(marketlist.zqdm);


  // }

  $("#zqdm").css({
    "width": "50%"
  });
  $("#zqmc").text(marketlist.zqmc);

  if ($("#consign .consign-type").text() == "限价委托") {
    // 未设置过委托价格且光标离开了价格输入框,则设置委托价格
    if (($("#price").val().length == 0 && order.isMouseLeavePriceInput) || order.isNeverInputPrice) {
      setWTJG(marketlist);
    }

  }

  //普通交易买卖界面隐藏的资金占用天数和购回价格说明
  if (getLocalData("page") == "买入" || getLocalData("page") == "卖出") {
    if (marketlist.zjzyts) {
      $("#zjzyts").val(marketlist.zjzyts);
    }
    if (marketlist.ghjg) {
      $("#ghjg").val(marketlist.ghjg);
    }
  }

  // 最近成交价 涨跌停价
  kmmslcxlist['market'] = {
    "zjcjj": marketlist.zjcjj,
    "ztjg": marketlist.ztjg,
    "dtjg": marketlist.dtjg
  };

  //==================分别计算买卖五档行情成交数量占总成交量的百分比==================
  var buyVolPer = calPrecent([marketlist.b1sl, marketlist.b2sl, marketlist.b3sl, marketlist.b4sl, marketlist.b5sl, marketlist.s1sl, marketlist.s2sl, marketlist.s3sl, marketlist.s4sl, marketlist.s5sl], [marketlist.b1sl, marketlist.b2sl, marketlist.b3sl, marketlist.b4sl, marketlist.b5sl]);
  var sellVolPer = calPrecent([marketlist.b1sl, marketlist.b2sl, marketlist.b3sl, marketlist.b4sl, marketlist.b5sl, marketlist.s1sl, marketlist.s2sl, marketlist.s3sl, marketlist.s4sl, marketlist.s5sl], [marketlist.s1sl, marketlist.s2sl, marketlist.s3sl, marketlist.s4sl, marketlist.s5sl]);


  //===============================填充五档行情页面内容========================================
  kmmslcxlist['prices'] = [

    {
      sellColor: setPriceColor(marketlist.s1jg, marketlist.zrspj),
      sellOrder: "卖1",
      sell: ZeroCheck(marketlist.s1jg),
      sellRatio: sellVolPer[0],
      sellVol: VolumeInt(marketlist.s1sl),
      buyColor: setPriceColor(marketlist.b1jg, marketlist.zrspj),
      buyOrder: "买1",
      buy: ZeroCheck(marketlist.b1jg),
      buyRatio: buyVolPer[0],
      buyVol: VolumeInt(marketlist.b1sl)
    }, {
      sellColor: setPriceColor(marketlist.s2jg, marketlist.zrspj),
      sellOrder: "卖2",
      sell: ZeroCheck(marketlist.s2jg),
      sellRatio: sellVolPer[1],
      sellVol: VolumeInt(marketlist.s2sl),
      buyColor: setPriceColor(marketlist.b2jg, marketlist.zrspj),
      buyOrder: "买2",
      buy: ZeroCheck(marketlist.b2jg),
      buyRatio: buyVolPer[1],
      buyVol: VolumeInt(marketlist.b2sl)
    }, {
      sellColor: setPriceColor(marketlist.s3jg, marketlist.zrspj),
      sellOrder: "卖3",
      sell: ZeroCheck(marketlist.s3jg),
      sellRatio: sellVolPer[2],
      sellVol: VolumeInt(marketlist.s3sl),
      buyColor: setPriceColor(marketlist.b3jg, marketlist.zrspj),
      buyOrder: "买3",
      buy: ZeroCheck(marketlist.b3jg),
      buyRatio: buyVolPer[2],
      buyVol: VolumeInt(marketlist.b3sl)
    }, {
      sellColor: setPriceColor(marketlist.s4jg, marketlist.zrspj),
      sellOrder: "卖4",
      sell: ZeroCheck(marketlist.s4jg),
      sellRatio: sellVolPer[3],
      sellVol: VolumeInt(marketlist.s4sl),
      buyColor: setPriceColor(marketlist.b4jg, marketlist.zrspj),
      buyOrder: "买4",
      buy: ZeroCheck(marketlist.b4jg),
      buyRatio: buyVolPer[3],
      buyVol: VolumeInt(marketlist.b4sl)
    }, {
      sellColor: setPriceColor(marketlist.s5jg, marketlist.zrspj),
      sellOrder: "卖5",
      sell: ZeroCheck(marketlist.s5jg),
      sellRatio: sellVolPer[4],
      sellVol: VolumeInt(marketlist.s5sl),
      buyColor: setPriceColor(marketlist.b5jg, marketlist.zrspj),
      buyOrder: "买5",
      buy: ZeroCheck(marketlist.b5jg),
      buyRatio: buyVolPer[4],
      buyVol: VolumeInt(marketlist.b5sl)
    }

  ];


  scope.kmmslcxlist = kmmslcxlist;

  // 扩大买卖五档价格点击区域
  setTimeout(function() {

    ExpendClickArea();

  }, 100);

}
/*=============================================================
函数功能：           五档行情查询
传入参数:        scope:angularJS作用域
=============================================================*/
function marketQuery(scope) {
  AJAX_FINISH = false;
  $("#zqdm").val(order.curzqdm);
  // 委托类型
  var wtlx = $("#consign .dropdown-menu.active li.active").attr("value");

  //========证券代码非空才允许进行可买卖数量查询============
  if ($("#zqdm").val().length || order.curzqdm) {
    // 限价委托查询可买卖数量或股份可用数时价格填输入价格
    if ($("#consign .consign-type").text() == "限价委托") {
      var price = $("#price").val();
    
      // 停牌股票 委托价格为零,未对停牌股票信息进行清除,
      if (parseFloat(price) == 0.00 || parseFloat(price) == 0.000) {
        price = "";
      }
      // 不是用户指定的价格，wtjg字段一律送空
      if (!controller["scope"].userSpecifyPrice) {
        price = "";
      }

    } // 市价委托查询可买卖数量或股份可用数时价格填空
    else {
      if ($("#consign .consign-type").text().trim() != "限价委托" && order.curzqlb == 'w') {
        var price = $("#price").val();
      } else {
        var price = "";
      }
    }
    var postData = {

      "zqdm": order.curzqdm ? order.curzqdm : "", //证券代码
      "gddm": order.curgddm ? order.curgddm : "", //股东代码
      "jysdm": "", //交易所代码
      "wtjg": price, //委托价格
      "wtlx": wtlx // 委托类型
    };

    if (getLocalData("page") == "融资买入") {
      if ($("#consign .consign-type").text() == "限价委托") {
        var url = "rzrq/ptyw/rzmrkmmslcx";
      } else if ($("#price").val() == "市价委托"  || ($("#consign .consign-type").text().trim() != "限价委托" && order.curzqlb == 'w')) {
        var url = "rzrq/ptyw/rzmrsjkmmslcx";
	// postData.mmlb=order.mmlb;                      //买卖类别
      } else {
        // 先执行success，再执行error，最后始终执行complete.
        AJAX_FINISH = true;
        return;
      }

    } // 融券卖出限价可买卖数量查询
    else if (getLocalData("page") == "融券卖出") {

      var url = "rzrq/ptyw/rqmckmmslcx";

    } else if (getLocalData("page") == "还券") {

      if ($("#HuanQuanType .btn.active").text() == "买券还券") {
        if ($("#consign .consign-type").text() == "限价委托") {
          var url = "rzrq/ptyw/mqhqkmmslcx";
        } else if ($("#price").val() == "市价委托" || ($("#consign .consign-type").text().trim() != "限价委托" && order.curzqlb == 'w')) {
          var url = "rzrq/ptyw/mqhqsjkmmslcx";
        } else {
          AJAX_FINISH = true;
          return;
        }
      } else if ($("#HuanQuanType .btn.active").text() == "现券还券") {
        queryHQSL();
        return;
      }

    } // 卖券还款限价可买卖数量查询
    else if ($("#HuanKuanType .btn.active").text().trim() == "卖券还款" && getLocalData("page") == "还款") {


      if ($("#consign .consign-type").text().trim() == "限价委托") {
        var url = "rzrq/ptyw/mqhkkmmslcx";
      } else if ($("#price").val().trim() == "市价委托" || ($("#consign .consign-type").text().trim() != "限价委托" && order.curzqlb == 'w')) {
        var url = "rzrq/ptyw/mqhksjkmmslcx";
      } else {
        return;
      }

    } else if (getLocalData("page") == "普通买入" || getLocalData("page") == "普通卖出") {

      if ($("#consign .consign-type").text().trim() == "限价委托") {
        postData.mmlb = order.mmlb; //买卖类别
        var url = "rzrq/ptyw/ptjykmmslcx";
      } else if ($("#price").val().trim() == "市价委托" || ($("#consign .consign-type").text().trim() != "限价委托" && order.curzqlb == 'w')) {
        postData.mmlb=order.mmlb;                      //买卖类别
        var url = "rzrq/ptyw/ptjysjkmmslcx";
      } else {
        return;
      }
    } else {

      if ($("#price").val().trim() == "市价委托" || ($("#consign .consign-type").text().trim() != "限价委托" && order.curzqlb == 'w')) {
        postData.mmlb = order.mmlb; //买卖类别
        var url = "ptjy/ptyw/sjkmmslcx";
      } else if ($("#consign .consign-type").text().trim() == "限价委托") {
        postData.mmlb = order.mmlb; //买卖类别
        var url = "ptjy/ptyw/kmmslcx";
      } else {
        return;
      }
    }

    $("#zqdm").val(order.curzqdm);
  } else {
    AJAX_FINISH = true;
    return;
  }

  // 自动输入证券代码时,不显示动态加载数据动画
  if (order.isHideLoad == true) {
    var showErr = false;
    var showLoaddingRun = false;

  } // 手动输入证券代码时,显示动态加载数据动画
  else {
    var showErr = true;
    var showLoaddingRun = true;
  }

  ajaxPost(getApiUrl() + url, postData, function(response) {
    KMMSLQuery(scope, response);
    AJAX_FINISH = true;

  }, function(response) {
    // 自动刷新时及用户改变价格时不提示错误信息
    if (order.isHideLoad == false || scope.enableAlert) {
      showAlert(response.cljg[0].message, "提示信息");
      controller["scope"].enableAlert = false;
      controller["scope"].userSpecifyPrice = false;
    }
    // 报错时，根据页面显示不同的买卖数量提示语
    var mmlb = '';
    if (getLocalData("page") == "融券卖出") {
        mmlb = '卖出';
      } else if (order.mmlb == "B") {
        mmlb = '买入';
      } else if (order.mmlb == "S") {
        mmlb = '卖出';
      }
    order.isFirstInputPrice = true;
    $("#volume").attr({
        "placeholder": "可" + mmlb + '--股'
    });

    // 查询出错的话,只能根据证券代码来判断交易所代码
    if (order.curzqdm.slice(0, 1) == "6") {
      order.curjysdm = "1";
    } else if (
      order.curzqdm.slice(0, 1) == "0" ||
      order.curzqdm.slice(0, 1) == "1" ||
      order.curzqdm.slice(0, 1) == "3"
    ) {
      order.curjysdm = "0";
    }

    //=========如果交易所代码不一样,重新初始化股东代码列表======
    if (order.curjysdm != order.lastjysdm) {
      //=======更新交易所代码历史值==========
      order.lastjysdm = order.curjysdm;
      //===========解析股东列表==================
      parseHolderList(order.curjysdm);
    }
    AJAX_FINISH = true;
  }, {
    isloaddingrun: showLoaddingRun,
    iserror: showErr

  });

}
/*=============================================================
函数功能：           对委托数量除以100取整
传入参数:              value:委托数量
=============================================================*/
function VolumeInt(value) {
  value = value ? value : 0;

  // 数据太长做截短处理
  // value=parseInt(value)+"";

  // console.log(value+" "+value.length);

  // if(value.length > 4 )
  // {
  //   var vol= value / 10000.00;
  //   return vol=parseFloat(vol).toFixed(2)+"万";
  // }

  return ZeroCheck(parseInt(SliceFixed(value, 0)));
}

/*=============================================================
函数功能：           设置委托价格
传入参数:      可买卖数量查询返回数据
=============================================================*/
function setWTJG(marketlist) {
  // 只有首次输入委托价格才能修改委托价格输入框的值
  if (order.isFirstInputPrice) {
    order.isFirstInputPrice = false;
  } else {
    return;
  }

  if (order.mmlb == "B") {
    if (marketlist.wtjg == "0.00" || marketlist.wtjg == "0.000") {
      $("#price").val(marketlist.zjcjj);
    } else {
      if (marketlist.wtjg != "") {
        $("#price").val(marketlist.wtjg);
      } else if (marketlist.b1jg != "") {
        $("#price").val(marketlist.b1jg);
      } else if (marketlist.zjcjj != "") {
        $("#price").val(marketlist.zjcjj);
      } else if (marketlist.zrspj != "") {
        $("#price").val(marketlist.zrspj);
      } else {
        $("#price").val("");
      }
    }
  } else if (order.mmlb == "S") {
    if (marketlist.wtjg == "0.00" || marketlist.wtjg == "0.000") {
      $("#price").val(marketlist.zjcjj);
    } else {
      if (marketlist.wtjg != "") {
        $("#price").val(marketlist.wtjg);
      } else if (marketlist.s1jg != "") {
        $("#price").val(marketlist.s1jg);
      } else if (marketlist.zjcjj != "") {
        $("#price").val(marketlist.zjcjj);
      } else if (marketlist.zrspj != "") {
        $("#price").val(marketlist.zrspj);
      } else {
        $("#price").val("");
      }
    }
  } else {
    $("#price").val("");
  }
}
/*=============================================================
函数功能：     获取股东代码数组
=============================================================*/
function getGDDMArr() {

  var j = 0,
    k = 0,
    m = 0,
    n = 0;

  //=============将股东代码进行分类====================
  if (getLocalData("ActivePTJYUser") || getLocalData("ActiveRZRQUser")) {
    // 普通业务登录信息
    if (params.ywlx == "ptjy" && getLocalData("ActivePTJYUser")) {
      var jsonData = JSON.parse(getLocalData("ActivePTJYUser"));
    } // 融资融券登录信息
    else if (params.ywlx == "rzrq" && getLocalData("ActiveRZRQUser")) {
      var jsonData = JSON.parse(getLocalData("ActiveRZRQUser"));
    } else {
      return;
    }

    for (var i = 0; i < jsonData["body"].gdlb.length; i++) {

      if (jsonData["body"].gdlb[i].jysdm == "0") {

        SZA[j++] = jsonData["body"].gdlb[i].gddm;

        if (jsonData["body"].gdlb[i].zcbz == "0") {
          mainGDZH.SZA = jsonData["body"].gdlb[i].gddm;
        }

      } else if (jsonData["body"].gdlb[i].jysdm == "1") {
        SHA[k++] = jsonData["body"].gdlb[i].gddm;


        if (jsonData["body"].gdlb[i].zcbz == "0") {
          mainGDZH.SHA = jsonData["body"].gdlb[i].gddm;
        }

      } else if (jsonData["body"].gdlb[i].jysdm == "2") {

        SZB[m++] = jsonData["body"].gdlb[i].gddm;

        if (jsonData["body"].gdlb[i].zcbz == "0") {
          mainGDZH.SZB = jsonData["body"].gdlb[i].gddm;
        }

      } else if (jsonData["body"].gdlb[i].jysdm == "3") {
        SHB[n++] = jsonData["body"].gdlb[i].gddm;

        if (jsonData["body"].gdlb[i].zcbz == "0") {
          mainGDZH.SHB = jsonData["body"].gdlb[i].gddm;
        }

      } else if (jsonData["body"].gdlb[i].jysdm == "4") {
        SBA[n++] = jsonData["body"].gdlb[i].gddm;

        if (jsonData["body"].gdlb[i].zcbz == "0") {
          mainGDZH.SBA = jsonData["body"].gdlb[i].gddm;
        }
      } else if (jsonData["body"].gdlb[i].jysdm == "5") {
        SBB[n++] = jsonData["body"].gdlb[i].gddm;

        if (jsonData["body"].gdlb[i].zcbz == "0") {
          mainGDZH.SBB = jsonData["body"].gdlb[i].gddm;
        }
      }
    }
  }
}

/*=============================================================
函数功能：            设置五档行情颜色
传入参数:  price:买卖价格   zrspj:昨日成交价
=============================================================*/
function setPriceColor(price, zrspj) {

  price = price ? price : 0;
  zrspj = zrspj ? zrspj : 0;

  // 价格 涨红跌绿平黑（此价格与昨收价比较：涨了是红色，跌了是绿色，平了是黑色）
  if (parseFloat(price) > parseFloat(zrspj)) {
    return "up-color";
  } else if (parseFloat(price) < parseFloat(zrspj)) {
    return "down-color";
  } else {
    return "none-color";
  }
}
/*=============================================================
函数功能：               零值检测
传入参数:             value:待检测值
=============================================================*/
function ZeroCheck(value) {

  return !value || value == "0.00" || value == "0.000" ? "--" : value;

}

/*==============================================
函数功能：         得到最小增量单位
传入参数:           price: 输入价格
==============================================*/
function getSmallCountUnit(price) {
  var smallUnit = "";

  var bits = countPointLength(price);

  if (bits == 0) {
    smallUnit = 1;
  } else {
    smallUnit = "0.";

    for (var i = 0; i < bits - 1; i++) {
      smallUnit = smallUnit + "0";
    }

    smallUnit = smallUnit + "1";
  }

  return smallUnit;
}
/*==============================================
函数功能：          自增减按钮绑定事件
传入参数:             param: 加减方向
==============================================*/
function AutoIncDec(param) {
  // 用户指定的价格，用于决定是否在marketQuery传人wtjg字段
  controller["scope"].userSpecifyPrice = true;

  order.isNeverInputPrice = false;

  //===============限价委托及科创板市价委托才允许输入价格===================
  if ($("#consign .consign-type").text() == "限价委托" || ($("#consign .consign-type").text().trim() != "限价委托" && order.curzqlb == 'w')) {

    var smallUnit = "";
    var price = $("#price").val();

    var bits = countPointLength(price);
    smallUnit = getSmallCountUnit(price);

    //==============总资产 委托单位价格不为空================
    if (price.length > 0) {
      var priceText;
      if (param.to == "Inc") {
        priceText = Inc(price, smallUnit, bits);
      } else if (param.to == "Dec") {
        priceText = Dec(price, smallUnit, bits);
      } else {
        return;
      }
      $("#price").val(priceText);
      order.isHideLoad = true;

      marketQuery(controller["scope"]);

    } else {
      showMessageTips("请先进行可买卖委托数量查询!");
    }

  }
}
/*===========================================================================
函数功能：               等分仓位
传入参数:            param: 等分仓位基数
============================================================================*/
function calcDepot(param) {
  hideKeyBoard();
  if (order.mmlb == "B" || order.gznhg || getLocalData("page") == "融券卖出") {
    //=======================判断委托单位 总资产是否为空=====================
    if (kmmsl.mmsl) {
      $("#volume").val(CalcKMMSL(kmmsl.mmsl, param.divi, kmmsl.wtdw, kmmsl.minNum));
    }
  } else if (order.mmlb == "S") {
    if (parseInt(kmmsl.gfkys) > 0) {
      //=========================计算可卖出数量====================
      $("#volume").val(CalcKMMSL(kmmsl.gfkys, param.divi, "股", kmmsl.minNum));
    }

  } else {
    return;
  }
}

/*================================================
函数功能: 担保品划转------划转数量查询
================================================*/
function queryHZSL() {

  var url = "";
  var postData = {

    "zqdm": $("#zqdm").val(), //证券代码
    "gddm": "", //股东代码
    "jysdm": "", //交易所代码
    "wtjg": "", //委托价格
    "mmlb": "S" //买卖类别
  };

  $("#zqdm").css({
    "width": "70%"
  });

  if (trim($("#DBPHZType button.active").text()) == "普通转信用") {
      url = "rzrq/ptyw/dbphzkmmslcx";
      postData.wtlx = "28";
  } else if (trim($("#DBPHZType button.active").text()) == "信用转普通") {
      url = "rzrq/ptyw/dbphzkmmslcx";
      postData.wtlx = "29";
  } else {
    return;
  }

  ajaxPost(getApiUrl() + url, postData, function(response) {

    order.isStopAutoQuery = true;

    if ($("#zqmc").text().length == 0) {
      $("#zqmc").text(response.kmmxx[0].zqmc);
    }
    $("#zqdm").val(response.kmmxx[0].zqdm);

    if ($("body").hasClass("rzrq-dbphz") == true) {
      $("#jysdm").text(response.kmmxx[0].jysdm);
    }

    var gfkys = response.kmmxx[0].gfkys ? response.kmmxx[0].gfkys : 0;
    $("#volume").attr({
      "placeholder": "可划转" + parseInt(gfkys) + "股"
    });

    gdzhInit(response.kmmxx[0].jysdm);
  });
}
/*================================================
函数功能:  现券还券------还券数量查询
================================================*/
function queryHQSL() {
  var postData = {

    "zqdm": $("#hqzqdm").val(), //证券代码
    "gddm": order.curgddm ? order.curgddm : "", //股东代码
    "jysdm": "", //交易所代码
    "wtjg": "", //委托价格
    "mmlb": "B" //买卖类别

  };

  ajaxPost(getApiUrl() + "rzrq/ptyw/zjhqkmmslcx", postData, function(response) {


    fullHQSL(response);

    AJAX_FINISH = true;

  });


}
/*==============================================
函数功能：        填充还券数量
传入参数:     response:服务器返回数据
==============================================*/
function fullHQSL(response) {

  $("#hqzqdm").css({
    "width": "50%"
  });
  $("#hqzqmc").text(response.kmmxx[0].zqmc);

  order.curjysdm = response.kmmxx[0].jysdm;
  order.curgddm = response.kmmxx[0].gddm;

  var gfkys = response.kmmxx[0].gfkys ? response.kmmxx[0].gfkys : 0;
  var wtdw = response.kmmxx[0].wtdw ? response.kmmxx[0].wtdw : "股";
  var khqsl = response.kmmxx[0].khqsl ? response.kmmxx[0].khqsl : 0;

  $("#xqhq-yhsl").text(khqsl + wtdw);
  $("#hqvolume").attr({
    "placeholder": "可还券" + gfkys + wtdw
  });

  order.isStopAutoQuery = true;
}

/*==============================================
函数功能：  检测证券代码查询条件是否满足
传入参数:     scope:angularJS作用域
==============================================*/
function checkStkCodeChange(scope, zqdm) {

  //===================(港股是5位,暂不考虑)===============
  if ($(zqdm).val().length == 6) {

    if (CheckIsPlus($(zqdm))) {
      //=====当输入股票代码为6位时,延时5s后关闭软键盘,留给用户5s修改时间=======
      //===不能查询成功后关闭,因为网络通信出现故障的话，键盘就不会自动关闭=====

      hideKeyBoard();
      order.curzqdm = $(zqdm).val();
      order.isStopAutoQuery = false;
      order.isHideLoad = false;
      //切换股票后，先清空股票代码再查询可买卖数量
      order.curgddm = "";

      // 担保品划转界面解析所有的五档数据
      if ($("body").hasClass("rzrq-dbphz") == true) {
        queryHZSL();
      } else if ($("body").hasClass("huanquan") == true && trim($("#HuanQuanType .btn.active").text()) == "现券还券") {
        queryHQSL();
      } else {
        marketQuery(scope);
      }

    } else {
      clearBargainPageFullData("NoAjax");
    }
  }
  // else
  // {

  // }
  // else if($(zqdm).val().length > 6)
  // {

  //   hideKeyBoard();
  //   //==========限制证券代码的位数为6位============
  //   var zqdm=$(zqdm).val().slice(0,6);
  //   $(zqdm).val(zqdm);
  //   showMessageTips("证券代码长度不能超过6位!");
  // }
}

/*======================================================
函数功能:  填充input输入内容并根据条件完成响应的事件
传入参数:        param: 点击的软键盘键值
=====================================================*/
function fillInputContent(param) {
  if (param == "del") {
    // 当用户点击删除时，视为在输入
    order.isFirstInputPrice = false;
    controller["scope"].userSpecifyPrice = true;
    order.isNeverInputPrice = false;
    var _value = $("#" + params.id).val();
    if (_value.length > 0) {
      _value = _value.substring(0, _value.length - 1);
      $("#" + params.id).val(_value);
    }
  } else {
    // 输入小数点合法性判断
    if (params.id == "price" || params.id == "volume") {
      var InputValue = $("#" + params.id).val();

      if (params.id == "volume" && param == ".") {
        showMessageTips("委托数量不允许有小数点!");
        return;
      } else if (params.id == "price") {
        controller["scope"].userSpecifyPrice = true;
        order.isFirstInputPrice = false;
        order.isNeverInputPrice = false;
        //===============检测输入框中已经有小数点================
        //========前提条件是软键盘一次只能输入一个字符===========
        if (InputValue.indexOf(".") >= 0) {
          // 如果输入值中已经有小数点, 输入的还是小数点则弹出提示框
          if (param == ".") {
            showMessageTips("委托价格不允许输入两位小数点!");
            return;
          } // 如果是其它字符则正常赋值
        }
      }

      $("#" + params.id).val($("#" + params.id).val() + param);


    } else if (params.id == "zqdm" || params.id == "hqzqdm") {
      $("#" + params.id).val($("#" + params.id).val() + param);
      order.curzqdm = $("#" + params.id).val();
      checkStkCodeChange(controller["scope"], "#" + params.id);
    } else {
      $("#" + params.id).val($("#" + params.id).val() + param);
    }

    if (params.id == "price") {
      controller["scope"].userSpecifyPrice = true;
      order.isFirstInputPrice = false;
      order.isNeverInputPrice = false;
      order.isHideLoad = true;
    }

  }
}
/*==========================================
函数功能:       解析股东代码
传入参数: arr: 股东代码数组 mgdzh:主股东代码
============================================*/
function holderParse(arr, mgdzh) {
  var list = "";
  var len = arr.length;
  var obj = {};
  var zcbzArr = [];

  // 存在主从标志时
  if (mgdzh) {
    var j = 1;

    // 将主代码显示在第一个
    for (var i = 0; i < len; i++) {
      //========股东代码默认选中值============
      if( arr[i] != undefined && arr[i].trim() == mgdzh.trim() ){
        zcbzArr[0] = mgdzh;
      } else {
        zcbzArr[j++] = arr[i];
      }
    }

  } // 没有主从吧标志的话按自然排序
  else {
    zcbzArr = arr;
  }

  for (var i = 0, len = zcbzArr.length; i < len; i++) {
    //========股东代码默认选中值============
    if (i == 0) {
      list += "<li class='active'>" + zcbzArr[i] + "</li>";
      order.curgddm = zcbzArr[i]; //解析默认股东代码
    } else {
      list += "<li>" + zcbzArr[i] + "</li>";
    }
  }

  //股东代码多于一个时,显示股东代码列表
  (len > 1) ? order.multiGD = true: order.multiGD = false;

  obj["list"] = list;

  return obj;
}
/*======================================================
函数功能:                    获取主股东账号
传入参数:    gdlb: 股东类别数组   isFind:是否找到标志位
=======================================================*/
function getMainAccount(gdlb, isFind) {
  // 若有主从标志,按主从标志解析
  // 若无主从标志,则默认第一个为主股东账号

  gdlb.zcbz = gdlb.zcbz ? gdlb.zcbz : "";

  if (gdlb.zcbz == "1") {
    return {
      gddm: gdlb.gddm,
      isFind: "true"
    };
  } else if (gdlb.zcbz == "") {
    return {
      gddm: gdlb.gddm,
      isFind: "true"
    };
  }

  return {
    gddm: "",
    isFind: "false"
  };
}
/*=================================================
函数功能:  解析股东代码和委托类型选项
传入参数:    jysdm: 交易所代码 zqlb: 证券类别
=================================================*/
function parseHolderList(jysdm, zqlb) {

  var gd = {}; // 股东列表

  if (jysdm == "0") {
    gd = holderParse(SZA, mainGDZH.SZA);
  } else if (jysdm == "1") {
    gd = holderParse(SHA, mainGDZH.SHA);
  } else if (jysdm == "2") {
    gd = holderParse(SZB, mainGDZH.SZB);
  } else if (jysdm == "3") {
    gd = holderParse(SHB, mainGDZH.SHB);
  }

  // 融券卖出发委托类型只有限价委托
  if (document.title.trim() != "融券卖出") {
    // 添加委托类型
    AppendConsignType(jysdm, zqlb);
  }


  //=======设置解析出来的第一个股东代码为默认股东代码
  $("#holder .holder-code").text(order.curgddm);
  //==========清空股东列表历史值=================
  $("#holder .dropdown-menu.active").html("");
  //===========向股东列表添加股东代码列表项================
  $("#holder .dropdown-menu.active").append(gd["list"]);


  // 多账号才显示股东列表
  if (order.multiGD == true) {
    $("#holder").show();
  } else {
    $("#holder").hide();
  }

}
/*==========================================================
函数功能:          向页面添加委托方式
传入参数:          jysdm: 交易所代码 zqlb: 证券类别
==========================================================*/
function AppendConsignType(jysdm, zqlb) {
  // 交易所代码不是0 1 2 3或空值,不予处理
  if (jysdm == '' || jysdm == '0' || jysdm == '1' || jysdm == '2' || jysdm == '3') {
    jysdm = jysdm ? jysdm : "0";

    //===================深市,沪市委托类型初始化====================
    var szConsignType = "<ul class='dropdown-menu active' role='menu'>" +
      "  <li class='active' value='0'>限价委托</li>" +
      "  <li value='1'>对方最优价格</li>" +
      "  <li value='2'>本方最优价格</li>" +
      "  <li value='3'>即时成交剩余撤销</li>" +
      "  <li value='4'>五档即成撤销</li>  " +
      "  <li value='5'>全额成交或撤销</li>" +
      "</ul>",

      shConsignType = "<ul class='dropdown-menu active' role='menu'>" +
      "  <li class='active' value='0'>限价委托</li>" +
      "  <li value='4'>最优五档即时成交剩余撤销</li>" +
      "  <li value='6'>最优五档即时成交剩余转限价</li>" +
      "</ul>";

    var kcbConsignType = "<ul class='dropdown-menu active' role='menu'>" +
      "  <li class='active' value='0'>限价委托</li>" +
      "  <li value='4'>最优五档即时成交剩余撤销</li>" +
      "  <li value='6'>最优五档即时成交剩余转限价</li>" +
      "  <li value='2'>本方最优价格</li>" +
      "  <li value='1'>对手方最优价格</li>" +
      "</ul>"; 
    $("#consign .select ul").remove();
    if (jysdm == "0" || jysdm == "2") {
      $("#consign .select button").after(szConsignType);
    } else if (jysdm == "1" || jysdm == "3") {
      if (zqlb === 'w') {
        $("#consign .select button").after(kcbConsignType);
      } else {
        $("#consign .select button").after(shConsignType);
      }
    }

    //设置默认选择项
    $("#consign .consign-type").text($("#consign").find(".dropdown-menu.active li").eq(0).text());


    //切换市场时,委托类型默认为限价委托,如果禁用了价格输入框,则应恢复正常输入功能
    $("#price").removeAttr("disabled");
    $(".btn-price").removeAttr("disabled");

  }

}

/*==============================================
函数功能：         显示右侧持仓窗口
==============================================*/
function showHold() {
  if (params.ywlx == "rzrq") {
    if ($("body").hasClass("huanquan")) {
      url = "rzrq/ptyw/wpchycx";
    } else {
      var url = "rzrq/ptyw/cccx";
    }
  } else if (params.ywlx == "ptjy") {
    var url = "ptjy/ptyw/cccx";
  } else {
    return;
  }

  var postData = {
    "qqhs": "1000", //Y 请求行数    每次取的行数
    "dwc ": "", //Y 定位串      第一次填空
    "cxfx": params['cxfx'] //Y 查询方向1   1向下/0向上查询方向
  };

  if ($("body").hasClass("huanquan")) {
    postData.zqdm = ""; //  N 证券代码    不送查全部
    postData.gddm = ""; //  N 股东代码    不送查全部
  }

  if (params['jybblx'] == "jzwin" && getLocalData("page") == "还券") {
    postData.rzrqfx = "2";
    dynGenerateNode(controller["scope"], controller["compile"], RightWindowColumnTwo);
  } else {
    dynGenerateNode(controller["scope"], controller["compile"], RightWindow);
  }

  angular.element($("body")).scope().$apply(function() {

    if ($("body").hasClass("huanquan")) {
      $(".ptjy-rzrq-tbody").hide();
      $(".kfsjj-tbody").show(); // 还券应还列表 显示列数为4列

      controller["scope"].thead = [
        {
          name: "合约编号"
        },
        {
          name: "应还证券"
        }, {
          name: "负债"
        },
      ];

      $("#right-window .title").hide();
    } else {

      $(".ptjy-rzrq-tbody").show(); // 显示列数为6列
      $(".kfsjj-tbody").hide();

      controller["scope"].thead = [

        {
          name: "股票市值"
        }, {
          name: "持仓/可用"
        }, {
          name: "成本/最新价"
        },
      ];
    }

  });

  //===============================设置滚动区域上边距===================================
  var tableHeight = document.documentElement.clientHeight - $(".scrollTable").offset().top;
  $(".scrollTable").height(tableHeight);

  //================================持仓查询==========================
  ajaxPost(getApiUrl() + url, postData, function(response) {

    if ($("body").hasClass("huanquan")) {
      var type = "rqfzcx";

      if ($("#HuanQuanType .btn.active").text().trim() == "买券还券") {
        var colNames = ["hybh", "zqmc", "zqdm", "dqfzsl"];
      } else if ($("#HuanQuanType .btn.active").text().trim() == "现券还券") {
        var colNames = ["hybh", "zqmc", "zqdm", "dqfzsl"];
      } else {
        return;
      }

    } else {
      var type = "cccx";
      var colNames = ["zqmc", "gpsz", "ccsl", "kysl", "cbjg", "dqjg", "zqdm"];
    }

    //=====================填充持仓表格数据=========================
    controller["scope"].rowHolds = FollowOriginalDataParse(response, colNames, type);
  });

};
/*==================================================================
函数功能：   点击了持仓列表某条持仓记录后,进行可买卖数量查询
传入参数:                obj:行对象
==================================================================*/
function FullBargainFrom(obj) {


  CloseModal();

  // 清除委托界面原有内容
  clearBargainPageFullData("NoAjax");

  order.isFirstInputPrice = true;

  if (params.ywlx == "ptjy" || params.ywlx == "rzrq") {

    if ($("body").hasClass("huanquan")) {
      //===========获取证券代码==========================
      order.curzqdm = trim($(obj).find("td").eq(1).find("p").eq(1).text());

      // 正确名称
      $("#zqmc").val($(obj).find("td").eq(1).find("p").eq(0).text());

    } else {
      //===========获取证券代码==========================
      order.curzqdm = $(obj).find("td").eq(2).find("p.zqdm").text().trim();

      // 正确名称
      $("#zqmc").val($(obj).find("td").eq(0).find("p").eq(0).text());


    }

    // 不显示加载出错信息
    order.isHideLoad = true;

    if ($("body").hasClass("huanquan") && trim($("#HuanQuanType button.active").text()) == "现券还券") {
      getHQSL(obj);
      return;
    }

    order.isNeverInputPrice = true;

    order.isStopAutoQuery = false;
    order.isFirstInputPrice = true;
    //切换股票后，先清空股票代码再查询可买卖数量
    order.curgddm = "";
    marketQuery(controller["scope"]);
  }

};
//===========================================
//     函数功能:  扩大买卖五档价格点击区域
//===========================================
function ExpendClickArea() {
  $(".sell-area, .buy-area").hover(function() {
    var index = $(this).parent("tr").index();

    if ($(this).hasClass("sell-area")) {
      $(".market tr").eq(index).children("td").eq(0).css({
        "background-color": "#F0F0F0"
      });
      $(".market tr").eq(index).children("td").eq(1).css({
        "background-color": "#F0F0F0"
      });
      $(".market tr").eq(index).children("td").eq(2).css({
        "background-color": "#F0F0F0"
      });
      $(".market tr").eq(index).children("td").eq(3).css({
        "background-color": "#F0F0F0"
      });
    } else {
      $(".market tr").eq(index).children("td").eq(4).css({
        "background-color": "#F0F0F0"
      });
      $(".market tr").eq(index).children("td").eq(5).css({
        "background-color": "#F0F0F0"
      });
      $(".market tr").eq(index).children("td").eq(6).css({
        "background-color": "#F0F0F0"
      });
      $(".market tr").eq(index).children("td").eq(7).css({
        "background-color": "#F0F0F0"
      });
    }

  }, function() {
    var index = $(this).parent("tr").index();
    if ($(this).hasClass("sell-area")) {
      $(".market tr").eq(index).children("td").eq(0).css({
        "background-color": ""
      });
      $(".market tr").eq(index).children("td").eq(1).css({
        "background-color": ""
      });
      $(".market tr").eq(index).children("td").eq(2).css({
        "background-color": ""
      });
      $(".market tr").eq(index).children("td").eq(3).css({
        "background-color": ""
      });
    } else {
      $(".market tr").eq(index).children("td").eq(4).css({
        "background-color": ""
      });
      $(".market tr").eq(index).children("td").eq(5).css({
        "background-color": ""
      });
      $(".market tr").eq(index).children("td").eq(6).css({
        "background-color": ""
      });
      $(".market tr").eq(index).children("td").eq(7).css({
        "background-color": ""
      });
    }
  })

}
//=========================================================================
//  函数功能: 当为市价委托时,点击涨停,跌停,最新价格,刷新委托价格
//=========================================================================
$("body").on("click", "div > .get-price", function() {
    order.isNeverInputPrice = false;
    var price = $(this).text();
    var bits = countPointLength(price);
    $("#price").val(SliceFixed(price, bits));
    controller["scope"].userSpecifyPrice = true;
    controller["scope"].enableAlert = false;
    marketQuery(controller["scope"]);
    return false;
  })
  //=========================================================================
  //  函数功能: 当为市价委托时,点击买卖五档价格,刷新委托价格
  //=========================================================================
$("body").on("click", ".buy-area, .sell-area", function() {

    var price = "";
    var index = $(this).parent("tr").index();


    if ($("#consign .consign-type").text() == "限价委托" || kmmsl.isKCB) {
      if ($(this).hasClass("sell-area")) {
        price = $(".market tr").eq(index).children("td").eq(1).text();
      } else if ($(this).hasClass("buy-area")) {
        price = $(".market tr").eq(index).children("td").eq(5).text();
      } else {
        return;
      }

      var bits = countPointLength(price);

      $("#price").val(SliceFixed(price, bits));
      order.isNeverInputPrice = false;
      controller["scope"].userSpecifyPrice = true;
      marketQuery(controller["scope"]);
    }

  })
  //===========================================
  //     函数功能: 计算小数点的位数
  //===========================================
function countPointLength(value) {

  if (value != null && value != '') {
    var decimalIndex = value.indexOf('.');
    if (decimalIndex == '-1') {
      return 0;
    } else {
      var decimalPart = value.substring(decimalIndex + 1, value.length);
      return decimalPart.length;
    }
  }
  return 0;
}


/*====================================================================
函数功能:          点击持仓背景遮罩区域,关闭持仓上浮层
====================================================================*/
$("body").on("click", "#RightWindow .modal-backdrop", function() {
  CloseModal();
});

/*====================================================================
函数功能:     设置股东选中值并根据条件进行可买卖数量查询
====================================================================*/
$(document).delegate("#holder .dropdown-menu > li", "click", function() {
    $("#holder .dropdown-menu li").each(function() {
        if ($(this).hasClass("active")) {
          $(this).removeClass("active");
        }
      })
      //=============设置选中样式================
    if ($(this).hasClass("active") == false) {
      $(this).addClass("active");
    }

    //=============设置选中值================
    $("#holder button").text($(this).text());

    //============隐藏父div==================
    $(this).parent().hide();

    //================更新股东代码===============
    order.curgddm = $(this).text();

    //=========若股东代码不同,立刻进行可买卖数量查询=========
    if (trim($(this).text()) != order.lastgddm) {
      order.lastgddm = order.curgddm  ;
      marketQuery(controller["scope"]);
    }

    //================点击事件禁止冒泡传播===================
    return false;

  })
  /*====================================================================
  函数功能:                委托方式选择
  ====================================================================*/
$(document).delegate("#consign .dropdown-menu > li", "click", function() {
  $("#consign .dropdown-menu li").each(function() {
    if ($(this).hasClass("active")) {
      $(this).removeClass("active");
    }
  });

  //========================设置选中项==============================
  $(this).parent().parent().find("button").eq(0).text($(this).text());

  // 切换委托类型，仓位计算是按照返回的kmsl进行计算，先清空买卖数量
  $("#volume").val("");
  if (trim($(this).text()) == "限价委托") {

    $("#price").val("");
    
    $("#price").attr({
      "placeholder": "请输入委托价格"
    });
    // 移除价格输入框的禁用属性
    $("#price").removeAttr("disabled");
    $(".btn-price").removeAttr("disabled");

    order.isFirstInputPrice = true;
  } else {
    if (kmmsl.isKCB) {
      if(order.mmlb === 'B') {
        $("#price").attr({
          "placeholder": "请输入买入保护限价"
        });
      } else {
        $("#price").attr({
          "placeholder": "请输入卖出保护限价"
        });
      }
      $(".btn-price").removeAttr("disabled");
      $("#price").val("");
    } else {
      $("#price").val("市价委托");
      $("#price").attr({
        "disabled": "disabled"
      });
      
    $(".btn-price").attr({
        "disabled": true
      });
    }
  }

  if ($(this).hasClass("active") == false) {
    $(this).addClass("active");
  }

  $(this).parent().hide();

  marketQuery(controller["scope"]);

  return false;

})

/*====================================================================
函数功能:                还款方式选择
====================================================================*/
function delegateKMC_HKFS(type) {
  var zqdm_onclick_attr_temp = $("#zqdm").attr("onclick");

  $(document).delegate("#kmc-hkfs .dropdown-menu > li", "click", function() {
    $("#kmc-hkfs .dropdown-menu li").each(function() {
      if ($(this).hasClass("active")) {
        $(this).removeClass("active");
      }
    });

    $(this).parent().parent().find("button").eq(0).text($(this).text());

    if ($(this).hasClass("active") == false) {
      $(this).addClass("active");
    }

    if ("指定合约还款" == $(this).text()) {
      // 清除委托界面原有内容
      clearBargainPageFullData("NoAjax");
      // 显示合约编号项
      $("#kmc-hybh").removeClass("hide");
      $("#kmc-hyzqmc").removeClass("hide");
      $("#kmc-hyrzje").removeClass("hide");
      $("#kmc-hyrzlx").removeClass("hide");
      $("#kmc-hydqr").removeClass("hide");
      // 查询合约编号并显示到下拉框中
      queryHYBH();
      // 禁止点击证券代码输入框触发弹出自定键盘事件
      $("#zqdm").removeAttr("onclick");

    } else {
      // 隐藏合约编号、证券名称、融资金额、融资利息、合约到期日
      $("#kmc-hybh").addClass("hide");
      $("#kmc-hyzqmc").addClass("hide");
      $("#kmc-hyrzje").addClass("hide");
      $("#kmc-hyrzlx").addClass("hide");
      $("#kmc-hydqr").addClass("hide");
      // 启用点击证券代码输入框触发弹出自定键盘事件
      $("#zqdm").attr("onclick", zqdm_onclick_attr_temp);
      //系统自动顺序还款 为总的需还款额
      if("现金还款" == $("#HuanKuanType .active").text().trim() ){
        $("#zfzjehj").text($("#zfzjehj").attr("zfzjehj"));
      }
    }

    $(this).parent().hide();

    return false;
  });
}


/*====================================================================
函数功能:                合约编号选择
====================================================================*/
function delegateKMC_HYBH(type) {
  $(document).delegate("#kmc-hybh .dropdown-menu > li", "click", function() {
    $("#kmc-hybh .dropdown-menu li").each(function() {
      if ($(this).hasClass("active")) {
        $(this).removeClass("active");
      }
    });

    $(this).parent().parent().find("button").eq(0).text($(this).text());

    if ($(this).hasClass("active") == false) {
      $(this).addClass("active");
    }

    var title = $("#HuanKuanType .active").text().trim();
    if (title == "卖券还款") {
      // 清除委托界面原有内容
      clearBargainPageFullData("NoAjax");
      // 从合约编号下拉框列表取得证券代码
      var zqdm = $("#kmc-hybh .dropdown-menu li.active").attr("value").trim();
      params.id = "zqdm";
      fillInputContent(zqdm);
    }else if(title == "现金还款"){ // 现金还款，需还款额为每只股票单独的数值
      $("#zfzjehj").text(formatNumber($(this).attr("xhke"), 0));
      $ ("#hyzqmc").text ($(this).attr("zqmc"));
      $("#hyrzje").text(formatNumber($(this).attr("hyrzje"), 0));
      $("#hyrzlx").text(formatNumber($(this).attr("hyrzlx"), 0));
      $ ("#hydqr").text ($(this).attr("hydqr"));
    }

    $(this).parent().hide();

    return false;
  });
}

/*====================================================================
函数功能:                查询合约编号
====================================================================*/
function queryHYBH() {
  var postData = {
    "htbh": "",
    "cxfx": "1",
    "qqhs": "1000",
    "dwc": "",
    "qsrq": "",
    "zzrq": "",
    "rzrqfx": "1",
  };

  ajaxPost(getApiUrl() + "rzrq/ptyw/wpchycx", postData, function(response) {
    var li = "";
    var cxlb = response.cxlb;
    for (var i = 0, len = cxlb.length; i < len; i++) {
      if (i == 0) {
        li += '<li class="active" value="' + cxlb[i].zqdm + '" ' + ' whhyje="' + cxlb[i].whhyje + '" '+ ' xhke="' + cxlb[i].rzzfz + '" '+ ' zqmc="' + cxlb[i].zqmc + '" '+ ' hydqr="' + cxlb[i].jzrq + '" '+ ' hyrzje="' + cxlb[i].cjje + '" '+ ' hyrzlx="' + cxlb[i].rzlx + '" '+' hyrq="' + cxlb[i].wtrq + '" ' + (i == 1 ? 'class="active"' : '') + '>' + cxlb[i].hybh + '</li>';
      } else {
        li += '<li value="' + cxlb[i].zqdm + '" ' + ' whhyje="' + cxlb[i].whhyje + '" '+ ' xhke="' + cxlb[i].rzzfz + '" '+ ' zqmc="' + cxlb[i].zqmc + '" '+ ' hydqr="' + cxlb[i].jzrq + '" '+ ' hyrzje="' + cxlb[i].cjje + '" '+ ' hyrzlx="' + cxlb[i].rzlx + '" '+' hyrq="' + cxlb[i].wtrq + '" ' + (i == 1 ? 'class="active"' : '') + '>' + cxlb[i].hybh + '</li>';
      }
    }
    $("#kmc-hybh .dropdown-menu").empty();
    $("#kmc-hybh .dropdown-menu").append(li);

    if (cxlb.length > 0) {
      $("#kmc-hybh  .consign-type").text(cxlb[0].hybh);

      var title = $("#HuanKuanType .active").text().trim();
      if (title == "卖券还款") {
        params.id = "zqdm";
        fillInputContent(cxlb[0].zqdm);
      } else if (title == "现金还款") {
        //指定合约还款 为单独的股票还款额
        $ ("#zfzjehj").text (formatNumber(cxlb[0].rzzfz, 0));
        $ ("#hyzqmc").text (cxlb[0].zqmc);
        $("#hyrzje").text(formatNumber(cxlb[0].cjje, 0));
        $("#hyrzlx").text(formatNumber(cxlb[0].rzlx, 0));
        $ ("#hydqr").text (cxlb[0].jzrq);
      }
    }
  });
}

/*====================================================================
函数功能:                委托方式选择
====================================================================*/
// $(document).delegate("#RepayMethod .dropdown-menu > li","click",function()
// {

//   //========================设置选中项==============================
//   $(this).parent().parent().find("button").eq(0).text($(this).text());

//   if( $(this).text() == "指定合约还款")
//   {
//     $("#contract").show();
//   }
//   else
//   {
//     $("#contract").hide();
//   }

//   $(this).parent().hide();

//   return false;

// })

/*====================================================================
函数功能:                五档行情刷新点击选项事件
====================================================================*/
$("#refresh-page").click(function() {
  // 不显示加载出错信息
  order.isHideLoad = true;

  marketQuery(controller["scope"]);

})

/*====================================================================
函数功能:                自定义选择框点击选项事件
====================================================================*/
$(document).delegate(".dropdown-menu > li", "mouseenter", function() {
  var SelID = "#" + $(this).parent().parent().parent().attr("id");

  $(SelID + " .dropdown-menu > li.active").removeClass("active");

  if ($(this).hasClass("active") == false) {
    $(this).addClass("active");
  }

  return false;

});

var lastSel = ""; //上一次打开的自定义选择框
var curSel = ""; //当前打开的自定义选择框

/*====================================================================
函数功能:                显示-隐藏 自定义选择框
====================================================================*/
$(document).on("click", ".line.custom-select", function() {
  hideKeyBoard();
  var curSel = "#" + $(this).attr("id");

  //===当前打开选择框与上次打开的不同,则关闭上次打开的选择框
  if (curSel != lastSel) {
    if (lastSel != "") {
      $(lastSel + " .dropdown-menu.active").hide();
    }

    lastSel = curSel;

  }

  $(curSel + " .dropdown-menu.active").toggle();

  //====阻止点击事件向body节点传递============
  return false;
});

/*====================================================================
函数功能:           输入价格之后,进行可买卖数量查询
====================================================================*/
$("#price").blur(function() {

  order.isMouseLeavePriceInput = true;

  // 输入了委托价格
  if ($("#price").length > 0) {
    order.isNeverInputPrice = false;
    marketQuery(controller["scope"]);
  } else {
    order.isNeverInputPrice = true;
  }

});

// ====================================================================
// 函数功能:           点击界面上非选择框区域,关闭打开的选择框
// ====================================================================
$("#price").focus(function() {

  order.isNeverInputPrice = false;
});

/*====================================================================
函数功能:           点击界面上非选择框区域,关闭打开的选择框
====================================================================*/
$("body").click(function() {
  // 隐藏上次打开的select选择框
  if (lastSel != "") {
    $(lastSel + " .dropdown-menu.active").hide();
  }

  // 隐藏当前打开的select选择框
  if (curSel != "") {
    $(curSel + " .dropdown-menu.active").hide();
  }

});


/*====================================
函数功能:  定时刷新五档行情
====================================*/
setInterval(function() {
  curTime.myDate = new Date();

  // getDay() 返回一个整数值 0-6： 0 代表星期日， 1 代表星期一，2 代表星期二，以此类推
  if (
    curTime.myDate.getDay() >= 1 && curTime.myDate.getDay() <= 5 &&
    (params.ywlx == "rzrq" || params.ywlx == "ptjy")
  ) {

    curTime.hh = curTime.myDate.getHours();

    curTime.hh = curTime.hh < 10 ? "0" + curTime.hh : curTime.hh;

    curTime.mm = curTime.myDate.getMinutes();

    curTime.mm = curTime.mm < 10 ? "0" + curTime.mm : curTime.mm;

    curTime.hhmm = curTime.hh + ":" + curTime.mm;

    //===============================在交易时段,刷新行情==============================================
    if (
      (curTime.hhmm >= "09:15" && curTime.hhmm <= "11:30") ||
      (curTime.hhmm >= "13:00" && curTime.hhmm <= "15:30")
    ) {
      curTime.isTradeStage = true;
    } else {
      curTime.isTradeStage = false;
    }

  }

  order.isHideLoad = true; // 隐藏显示加载过程的动画

  //=========如果证券代码不为空,并且未禁用自动刷新,且在交易时段则执行刷新操作,ajax请求是否完成===========================
  if ($("#zqdm").val().length > 0 && order.isStopAutoQuery == false && curTime.isTradeStage && AJAX_FINISH) {
    marketQuery(controller["scope"]);
  }

}, params['sxhqpl']);


getGDDMArr(); // 解析股东代码数组
