
/**
 * 新股申购详细页面
 * $Date: 2015-07-13 15:35:20 +0800 (周一, 2015-07-13) $
 * $Revision: 4530 $
 * $Author: guoqf $
 */

var ywlx = $("body").attr("data-ywlx");
var dataList = getLocalData("dataList"); //  从本地存储中获取上一页面中新股信息
var step = 1000; // 步长  沪市 1000 , 深市 500，科创板500，取后端的sgdw

var app = angular.module('xgxq', []);

app.controller('xgxqController', function($rootScope, $scope, $http, $compile) {

    var modal_level = 1; // 模态框级别
    dataList = dataList == null ? {} : JSON.parse(dataList);

    $scope.userAgent = navigator.userAgent;
    $scope.stockName = dataList.zqmc || "";
    $scope.stockCode = dataList.zqdm || "";
    $scope.purchase = "申购";
    $scope.show_sq_btn = true;

    if (dataList.sgtype !== 'today') {
        $scope.show_sq_btn = false;
    }


    // 网上申购上限(元)  如果服务器没有下发数据, 则 "待定" 显示.
    var wssgsx_y = isNaN(dataList.wsfxsl) ? dataList.wsfxsl : isNaN(dataList.fxjg) ? dataList.fxjg : formatNumber(amount_calculation(dataList.sgxe, dataList.fxjg), 0)
    if (dataList.sgtype === 'today') {
        $scope.rowDetails   = [
            { name: "申购价格"       , value: dataList.sgjg},
            //{ name: "资金解冻日" , value: formatDate(dataList.zjjdrq || "", "yyyy-MM-dd")},
            { name: "申购单位"      , value: dataList.sgdw || "" },
            { name: "申购最小数量"   , value: dataList.sgzxsl},
            { name: "申购最大数量"   , value: dataList.sgzdsl},
            { name: "发行方式"       , value: dataList.fxfs == '0' ? '申购' : '配售'},
            { name: "发行日期"       , value: formatDate(dataList.sgrq || "", "yyyy.MM.dd")},
        ];
    } else {
        $scope.rowDetails   = [
            { name: "申购日期"            , value: formatDate(dataList.fxrq || "", "yyyy-MM-dd")},
            //{ name: "资金解冻日"          , value: formatDate(dataList.zjjdrq || "", "yyyy-MM-dd")},
            { name: "发行价格"            , value: dataList.fxjg || "" },
            { name: "发行市盈率(倍)"      , value: (!isNaN(dataList.fxsyl) ? dataList.fxsyl : dataList.fxsyl)},
            { name: "总发行数量(万股)"    , value: parseFloatW(dataList.zfxsl)},
            { name: "网上发行数量(万股)"  , value: parseFloatW(dataList.wsfxsl)},
            { name: "网上申购上限(万股)"  , value: parseFloatW(dataList.sgxe)},
            { name: "网上申购上限(元)"    , value: wssgsx_y}
        ];
    }
    // 屏蔽显示数据
    $scope.baseContent = "";
    $scope.newsTitles = [];

    /*==========================================================
      触发条件：点击页面 [ 申购 ] 按钮
    ===========================================================*/
    $scope.sq_btn = function() {
        // 显示申购的模态框
        sg_show_modal();
    }

    /*==============================================
      触发条件：点击模态框中的 [ + ] 按钮
      执行功能：
    ===============================================*/
    $scope.plus = function() {
        if (check_number("+")) {
            plusMinus("number", "plus", step);
        }

        //显示金额
        show_price($scope, modal, "number");
    }

    /*==============================================
      触发条件：点击模态框中的 [ - ] 按钮
      执行功能：
    ===============================================*/
    $scope.minus = function() {
        if (check_number("-")) {
            plusMinus("number", "minus", step);
        }

        //显示金额
        show_price($scope, modal, "number");
    }

    /*===========================
      显示APP自定义键盘
    ============================*/
    $scope.showKeyboard = function(id) {
        showKeyboard(id, '1');
    }

    /*==============================================
      触发条件：点击模态框中的 [ 确定 ] 按钮
      执行功能：
    ===============================================*/
    $scope.Ensure = function() {
        if (modal_level == 1) { // 申购模态框点击 “确定” 按钮

            var tips = "";

            // 如果申购限制等于 0 , 则不能申购新股
            if (maxNumber == 0) tips = "您的申购限额为 0, 无法下单";

            var number = $("#number").val();
            number = number.trim() == "" ? 0 : number;

            if (number == 0) tips = "请输入申购数量";

            // 申购数量为所在交易所申购单位的整数倍; 深市: 500, 沪市: 1000
            if (parseFloat(number) % step > 0) tips = "申购数量应为" + step + "股整数倍";

            if (tips != "") {
                showMessageTips(tips, "40");
                return;
            }

            // 因为申购数量可能是键盘输入, 需要重新计算下显示金额
            show_price($scope, modal, "number");

            // 委托数量
            dataList['wtsl'] = $("#number").val();
            // 申购金额
            var sqje = calculate_price(modal['content'][4].value, $("#number").val()) + "元";
            dataList['sgje'] = sqje;

            // 关闭模态框
            CloseModal();

            // 申购确认模态框
            sgqr_show_modal();
        } else if (modal_level == 10) { // 申购确认模态框点击 “确定” 按钮
            // 关闭模态框
            CloseModal();

            // 委托下单
            wtxd_order();
        } else if (modal_level == 100) { // 委托下单后显示的模态框点击 “确定” 按钮
            // 关闭模态框
            CloseModal();

            //刷新页面
            window.location.reload();
        } else {
            // 关闭模态框
            CloseModal();
        }
    };

    /*=============================================
      函数功能：申购显示的模态框
    ==============================================*/
    function sg_show_modal() {
        modal_level = 1;

        modal = {};

        step = dataList.sgdw;
        xg_fxjg = dataList.fxjg;

        modal["title"] = "申购";

        modal["content"] = [{
            "key": "证券名称",
            "value": dataList.zqmc
        }, {
            "key": "申购代码",
            "value": dataList.sgdm
        }, {
            "key": "申购上限",
            "value": dataList.sgzdsl + "股"
        }, {
            "key": "申购额度",
            "value": "--"
        }, {
            "key": "申购价格",
            "value": dataList.sgjg
        }];

        // 解析股东代码
        var gddms = parseGddmList(dataList.jysdm);

        // 用户没有股东代码时
        if (gddms.length == 0) {
            showMessageTips("您没有 [" + dataList.zqdm + "] 所在交易所的股东代码，不能进行申购!", "40");
            return;
        }

        // 用户股东代码数大于 1 时，显示股东代码列表由客户选择
        if (gddms.length > 1) {
            modal["select"] = [{
                key: "股东代码",
                opteions: []
            }];

            modal["select"][0]['options'] = [];

            for (var i in gddms) {
                modal["select"][0]['options'].push({
                    value: gddms[i],
                    text: gddms[i]
                });
            }

            // 设置默认显示的股东代码
            modal["select"][0]['options']['selectVal'] = gddms[0];
        }

        var sqje = calculate_price(dataList.sgxe, dataList.fxjg) + "元";

        modal['numbers'] = [{
            id: "number",
            plus: "BtnPlusRed",
            minus: "BtnMinusRed",
            value: ""
        }];

        modal['footerMsg'] = [{
            value: footerMsg(dataList.jysdm, dataList.zqlb)
        }];

        // 申购限额
        maxNumber = dataList.sgxe;
        // 股东代码
        dataList['gddm'] = gddms.length == 1 ? gddms[0] : modal["select"][0]['options']['selectVal'];

        // 新股额度查询
        xgedcx(dataList.jysdm, function(response) {
            var _cxlb = response.cxlb;
            var len   = _cxlb.length;
            var ksged = 0;
            for (var i = 0; i < len; i++) {
                if (dataList.jysdm == _cxlb[i].jysdm) {
                    if (dataList.jysdm === '1' && dataList.zqlb === 'w') {
                        ksged = _cxlb[i].kcbksged;
                    } else {
                        ksged = _cxlb[i].ksged;
                    }
                    break;
                }
            }

            maxNumber = len == 0 ? 0 : parseFloat(ksged) < maxNumber ? parseFloat(ksged) : maxNumber;

            modal["content"][3]["value"] = maxNumber + "股";

            // 创建模态框
            create_modal($scope, $compile, modal);

            // 延迟加载
            setTimeout(function() {
                $("#number").val(maxNumber);
            }, 200);
        });
    }

    /*=============================================
      函数功能：可买卖数量查询
    ==============================================*/
    function kmmslcxQuery(zqdm, gddm, jysdm, wtjg, method) {
        var request = {
            zqdm: zqdm,
            gddm: gddm,
            jysdm: jysdm,
            mmlb: "P",
            wtjg: wtjg
        };

        var lastUrl = "ptjy/xgsg/kmmslcx";

        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/kmmslcx";
        }

        ajaxPost(getApiUrl() + lastUrl, request, function(response) {
            method(response);
        });
    }

    /*================================================
      函数功能：申购确认显示的模态框
    ================================================*/
    function sgqr_show_modal() {
        modal_level = 10;

        modal = {};

        modal["title"] = "申购确认";

        modal["content"] = [{
            "key": "申购代码",
            "value": dataList.sgdm
        }, {
            "key": "证券名称",
            "value": dataList.zqmc
        }, {
            "key": "申购数量",
            "value": dataList.wtsl || "0"
        }, {
            "key": "申购金额",
            "value": dataList.sgje || "0"
        }];

        // 创建模态框
        create_modal($scope, $compile, modal);
    }

    /*================================================
      函数功能：委托下单
    ================================================*/
    function wtxd_order() {
        var request = {
            jysdm: dataList.jysdm,
            gddm: dataList.gddm,
            mmlb: "B",
            zqdm: dataList.sgdm,
            wtjg: dataList.sgjg,
            wtsl: dataList.wtsl
        };

        console.log(JSON.stringify(request));
        var lastUrl = "ptjy/xgsg/wtxd";

        if (ywlx == "rzrq") {
            request.ywlx = "rzrq";
            lastUrl = "rzrq/xgsg/wtxd";
        }

        ajaxPost(getApiUrl() + lastUrl, request, function(response) {
            wtxd_show_modal(params.message.xgsg_success);
        });
    }

    /*================================================
      函数功能：委托下单显示的模态框
    ================================================*/
    function wtxd_show_modal(msg) {
        modal_level = 100;

        modal = {};

        modal["title"] = "申购";

        modal["msg"] = [{
            value: msg
        }];

        // 创建模态框
        create_modal($scope, $compile, modal, true);
    }

}); // angularjs 控制器结束
