/**
 *
 * $Date: 2015-07-15 18:36:43 +0800 (周三, 2015-07-15) $
 * $Revision: 4708 $
 * $Author: guoqf $
 */

/**====================== 银行转证券与证券转银行的按钮样式切换 =======================*/
$(".btn-group > button").click(function() {
  $(".btn-group .btn.btn-default.active").removeClass("active");
  $(this).addClass("active");
});

// 业务类型 ptjy: 普通交易; rzrq: 融资融券
var ywlx              = $("body").attr("data-ywlx");
// 按钮类型  1: 查余额  2: 银证转账
var btn_type          = 0;
// 多账户银行查询返回的数据对象
var dataList          = [];
// 列表数据的索引 ID
var dataList_index    = 0;
// 转帐类型  '1': 银行转证券  '2':证券转银行
var zhlx              = "1";

// showMessageTips("ywlx = " + ywlx);

var app = angular.module('yzzz', []);

var $$scope = null;

app.controller('yzzzController', function($rootScope, $scope, $http, $compile) {
  $scope.userAgent = navigator.userAgent;

  $$scope = $scope;

  // 模态框需要的数据对象
  var modal             = {};
  // 默认显示值
  var default_selectVal = "";
  // 多账户资金查询返回的数据对象
  var dzhzjcxList       = [];


  $scope.bankToStock    = "银行转证券";
  $scope.stockToBank    = "证券转银行";

  //可取金额
  $scope.zqje           = "";
  //银行余额
  $scope.yhye           = "";
  //输入金额提示
  $scope.amount_pla     = "请输入你要转入的金额";

  loading();

  // 提供原生回调刷新页面数据
  handlePageBack = function() {
      loading();
  }

  function loading () {
    var request = {};

    var lastUrl = "ptjy/yzzz/dzhyhcx";

    if (ywlx == "rzrq") {
      request.ywlx = "rzrq";
      lastUrl      = "rzrq/yzzz/dzhyhcx";
    }

    ajaxPost(getApiUrl() + lastUrl, request, function(response){
      dataList = response.cxlb;

      var len = dataList.length;
      var tempData = dataList[0];
      if (len > 1) {
        for (var temp = 0; temp < len; temp++) {
          if (dataList[temp].zcbz == "0") {
            dataList[0] = dataList[temp];
            dataList[temp] = tempData;
            break;
          }
        }
      }
      for (var i = 0; i < len; i++) {
        //dataList[i]['text'] = dataList[i].yhmc + " 尾号" + toLastFixed4(dataList[i].yhzh);
        dataList[i]['text'] = dataList[i].yhmc;
      }

      $scope.hbdm = params['bz'][dataList[0].hbdm];
      $scope.dataList = dataList;
      cyeShowOrHide (0);

      setTimeout(function(){
        if(dataList.length > 0) {
          setDivselectValue($(".divselect>p:eq(0)"));
        }

        Zjcx();
      }, 200);
    });
  }

  /*====================================================
    触发条件：银行列表下拉框change事件
    执行功能：1、切换右边显示的货币图标
  ====================================================*/
  $scope.selectChange = function(index) {
    if (dataList.length > 0) {
      $scope.hbdm = params['bz'][dataList[index].hbdm];

      cyeShowOrHide(index);

      if (zhlx == 2) {
        setTimeout(function() {
          showkcje();
        }, 300);
      }
    }
  }

  /*====================================================
    触发条件：点击页面[确定]按钮
    执行功能：弹出提示框[转账确认]
  ====================================================*/
  $scope.yzzz = function() {
    // 隐藏自定键盘
    hideKeyBoard();

    var yhzh = dataList[$("#transaccount").val()];
    var amount = $("#amount").val();

    if ($("#transaccount").val() == undefined || $("#transaccount").val() == "") {
      showMessageTips("请选择银行卡!");
      return;
    }

    if (amount.length == 0) {
      showMessageTips(zhlx == 1 ? "请输入您要转入的金额" : "请输入您要转出的金额");
      return;
    }
    if (!CheckMoney(amount)) {
      showMessageTips("请输入正确的金额");
      return;
    }

    modal = {};

    var zrje_key = zhlx == "1" ? "转入金额" : "转出金额";
    var text_key = zhlx == "1" ? "转入银行" : "转出银行";

    modal['title'] = "转账确认";
    modal['content'] = [{
      key: zrje_key,
      value: formatNumber(amount) + params['bzmc'][yhzh.hbdm]
    }, {
      key: text_key,
      value: yhzh.text
    }];
    //modal['single'] = [{value:yhzh.text}];
    modal['inputbox'] = [];

    // 判断是否需要显示密码输入框
    var mm = mmshow(yhzh);

    // 显示银行密码输入框
    if (mm.yhmmshow) {
      modal['inputbox'].push({
        id: "yhmm",
        key: "银行密码",
        value: "请输入银行密码"
      });
    }
    // 显示资金密码输入框
    if (mm.zjmmshow) {
      modal['inputbox'].push({
        id: "zjmm",
        key: "资金密码",
        value: "请输入资金密码"
      });
    }

    // 银行转证券时, 不需要银行密码时, 增加安全提示语
    if (zhlx == 1 && yhzh.zrmmpz == 0) {
      modal['btnBeforeMsg'] = [{
        value: "您的存管银行提供三方存管免密转账服务，本次资金转入无需输入资金密码。"
      }];
    }

    btn_type = 2;

    create_modal($scope, $compile, modal, false);
  };

  /*====================================================
    触发条件：点击页面[查余额]
    执行功能：弹出提示框[余额查询]
  ====================================================*/
  $scope.checkBalance = function() {
    if (dataList.length == 0) {
      return;
    }

    var yhzh = dataList[$("#transaccount").val()];
    //var yhzh = { text: "000" };

    modal = {};

    modal['title'] = "余额查询";
    modal['content'] = [{
      key: "银行账户",
      value: yhzh.text
    }];
    // modal['single'] = [{value:yhzh.text}];
    modal['inputbox'] = [];

    //余额查询是否需要银行密码  0：不需要；1：需要
    if (yhzh.yhyemmpz == "2" || yhzh.yhyemmpz == "3") {
      modal['inputbox'].push({
        id: "yhmm",
        key: "银行密码",
        value: "请输入银行密码"
      });
    }
    //余额查询是否需要资金密码  0：不需要；1：需要
    if (yhzh.yhyemmpz == "1" || yhzh.yhyemmpz == "3") {
      modal['inputbox'].push({
        id: "zjmm",
        key: "资金密码",
        value: "请输入资金密码"
      });
    }

    btn_type = 1;
    create_modal($scope, $compile, modal, false);
  }


  //银行转证券
  $scope.bankToStockBtn = function() {
    zhlx = "1";
    $scope.amount_pla = "请输入你要转入的金额";
    $("#balance").show();
    $("#available").hide();


    // 切换时, 清空数据
    if (dataList.length > 0) {
      setDivselectValue($(".divselect>p:eq(0)"));
      cyeShowOrHide(0);
    }

    $("#amount").val("");

    if (!($("#transaccount").val() == undefined || $("#transaccount").val() == "")) {
      $("#transaccount").val("0");
      $scope.hbdm = params['bz'][dataList[$("#transaccount").val()].hbdm];
    }
  }

  //证券转银行
  $scope.stockToBankBtn = function() {
    zhlx = "2";
    $scope.amount_pla = "请输入你要转出的金额";

    // 切换时, 清空数据
    if (dataList.length > 0) {
      setDivselectValue($(".divselect>p:eq(0)"));
    }

    $("#amount").val("");

    $("#balance").hide();

    if (!($("#transaccount").val() == undefined || $("#transaccount").val() == "")) {
      $("#transaccount").val("0");
      $scope.hbdm = params['bz'][dataList[$("#transaccount").val()].hbdm];

      $("#available").show();

      // 显示可取金额
      setTimeout(function() {
        showkcje();
      }, 300);
    }

  }

  /*====================================================
    函数功能：显示可取金额
  ====================================================*/
  function showkcje(type) {
    var yhzh = dataList[$("#transaccount").val()];

    var hbdm = yhzh.hbdm;

    var assetsKey = ywlx == "ptjy" ? "ptjyAssets" : "rzrqAssets";

    console.log("[ index = " + $("#transaccount").val() + " , hbdm = " + hbdm + " , assetsKey = " + assetsKey + " ]");

    if (getLocalData(assetsKey)) {
      var assetsValue = JSON.parse(getLocalData(assetsKey));

      for (var i = 0, len = assetsValue.length; i < len; i++) {
        if (assetsValue[i].hbdm == hbdm) {
          var zjkqs = formatNumber(assetsValue[i].zjkqs, 2);

          $("#zqje").show();

          if (type == undefined) {
            $scope.$apply(function() {
              $scope.zqje = zjkqs;
            });
          } else {
            $scope.zqje = zjkqs;
          }
        }
      }
    }

  }

  /*====================================================
    函数功能：资金查询
  ====================================================*/
  function Zjcx() {
    var lastUrl = ywlx == "ptjy" ? "ptjy/ptyw/zjcx" : "rzrq/ptyw/zjcx";

    var request = {
      hbdm: ""
    };

    if (ywlx == "rzrq") {
      request['ywlx'] = "rzrq";
    }

    ajaxPost(getApiUrl() + lastUrl, request, function(response) {
      parseAssetsQuery(ywlx, response);

      showkcje("zjcx");
    });
  }


  /*====================================================
    函数功能：银证转账返回信息提示
  ====================================================*/
  function yzzz_message(stats) {
    CloseModal();

    modal = {};
    modal['title'] = "转账";
    modal['msg'] = [{
      value: params.message.yzzz_success
    }];
    btn_type = 100;
    create_modal($scope, $compile, modal, true);
  }

  //====================模态框确认按钮触发事件=============================
  $scope.Ensure = function() {
    // 查余额
    if (btn_type == 1) {
      var yhzh = dataList[$("#transaccount").val()];

      var yhmm = $("#yhmm").val() || "";
      var zjmm = $("#zjmm").val() || "";

      if (yhzh.yhyemmpz == "2" || yhzh.yhyemmpz == "3") {
        if (yhmm.length == 0) {
          showMessageTips("请输入银行密码");
          return;
        } else if (yhmm.length < 6) {
          showMessageTips("银行密码不能小于6位");
          return;
        }
      }

      if (yhzh.yhyemmpz == "1" || yhzh.yhyemmpz == "3") {
        if (zjmm.length == 0) {
          showMessageTips("请输入资金密码");
          return;
        } else if (zjmm.length < 6) {
          showMessageTips("资金密码不能小于6位");
          return;
        }

      }

      CloseModal();

      // 入参：银行余额查询 银行代码/银行密码/资金密码/货币代码
      var request = {
        yhdm: yhzh.yhdm,
        yhmm: yhmm,
        zjmm: zjmm,
        hbdm: yhzh.hbdm,
        dyzjzh: getDYZJZH($scope.dataList) //返回对应银行卡的资金账号
      };

      var lastUrl = "ptjy/yzzz/yhyecx";

      if (ywlx == "rzrq") {
        request.ywlx = "rzrq";
        lastUrl = "rzrq/yzzz/yhyecx";
      }

      var stopTimer = false;
      var time = 0;
      var timeLine = 500;
      var endTime = 20 * 1000;
      var timer_yz = null;
      var isQuery = false;

      ajaxPost(getApiUrl() + lastUrl, request, function(response) {
        // 委托序号
        var wtxh = response.fhxx[0].wtxh;

        // 银证转账查询 货币代码 / 银行代码 / 委托序号 / 查询方向 / 请求行数 / 定位串
        // var request = {"hbdm": yhzh.hbdm, "yhdm":  yhzh.yhdm,  "wtxh": wtxh, "cxfx": "1", "qqhs": "1", "dwc": "" };
        var request = {
          "hbdm": "",
          "yhdm": "",
          "wtxh": wtxh,
          "cxfx": "1",
          "qqhs": "1000",
          "dwc": ""
        };

        var lastUrl = "ptjy/yzzz/dryzzzlscx";

        if (ywlx == "rzrq") {
          request.ywlx = "rzrq";
          lastUrl = "rzrq/yzzz/dryzzzlscx";
        }

        timer_yz = setInterval(function(){
          time += timeLine;
          if (!isQuery) {
            isQuery = true;
            yecx(getApiUrl() + lastUrl, request);
          }

        }, timeLine);

      },
      function(response) {
        // 普通消息(模拟框)
        general_message("余额查询", response.cljg[0].message);
      });

      // 余额查询， 且显示
      function yecx(url, request) {
          //银证转账查询
          ajaxPost(url, request, function(response) {
            isQuery = false;

            // 银行余额
            var yhyeObj = null;

            for (var i = response.cxlb.length - 1, len = 0; i >= 0; i--) {
              if (response.cxlb[i].hbdm == yhzh.hbdm && response.cxlb[i].yhdm == yhzh.yhdm) {
                yhyeObj = response.cxlb[i];
                break;
              }
            }



            ////////////////////////////////////////////////////////////
            // 西藏同信余额查询zzzt字段:2为成功，3为失败，1为正在处理 //
            // 标准版本余额查询zzzt字段:0为成功，1为失败，2为正在处理 //
            ////////////////////////////////////////////////////////////
            if (yhyeObj != null) {
              var yhye = formatNumber(yhyeObj.zzje) + " " + yhyeObj.hbmc;

              if (yhyeObj.zzzt == "2") {
                yhye = "正在查询";
              }
              if (yhyeObj.zzzt == "1") {
                yhye = "查询失败";
                stopTimer = true;
              }

              if (yhyeObj.zzzt == "0") {
                stopTimer = true;
              }
              if (time >= endTime) {
                stopTimer = true;
                yhye = "查询失败";
              }

              $scope.yhye = yhye;
              $("#yhye").show();

              if (stopTimer) {
                clearInterval(timer_yz);
              } else {
                return;
              }

            } else {
              // 普通消息(模拟框)
              general_message("余额查询", response.cljg[0].message);
            }
          }, null, {isloaddingrun: false});
      }
    }

    // 银证转账
    else if (btn_type == 2) {
      var yhzh = dataList[$("#transaccount").val()];
      var amount = $("#amount").val();

      var yhmm = $("#yhmm").val() || "";
      var zjmm = $("#zjmm").val() || "";

      // 判断是否需要显示密码输入框
      var mm = mmshow(yhzh);

      if (mm.yhmmshow && yhmm.length == 0) {
        showMessageTips("请输入银行密码");
        return;
      }

      if (mm.zjmmshow && zjmm.length == 0) {
        showMessageTips("请输入资金密码");
        return;
      }

      CloseModal();

      // 入参：银证转账 资金密码/银行密码/银行代码/转帐类型/货币代码/转账金额
      var request = {
        zjmm: zjmm,
        yhmm: yhmm,
        yhdm: yhzh.yhdm,
        zzlx: zhlx,
        hbdm: yhzh.hbdm,
        zzje: amount,
        dyzjzh: getDYZJZH($scope.dataList) //返回对应银行卡的资金账号
      };

      var lastUrl = "ptjy/yzzz/yzzz";

      if (ywlx == "rzrq") {
        request.ywlx = "rzrq";
        lastUrl = "rzrq/yzzz/yzzz";
      }

      ajaxPost(getApiUrl() + lastUrl, request, function(response) {
        yzzz_message(1);
      });
    } else if (btn_type == 100) {
      CloseModal();
      //已填数据清空
      dataList['selectVal'] = dataList[0].yhdm;

      $("#amount").val("");

      // 资金查询
      Zjcx();
    } else {
      CloseModal();
    }

    // 关闭自定义键盘
    hideKeyBoard();
  }

  /*======================================
   函数功能：普通消息(模拟框)
  ======================================*/
  function general_message(title, msg) {
    modal = {};
    modal['title'] = title;
    modal['msg'] = [{ value: msg }];

    btn_type = 0;
    create_modal($scope, $compile, modal, true);
  }

  /*===========================
    显示APP自定义键盘
  ============================*/
  $scope.showKeyboard = function(id) {
    showKeyboard(id, '3');
  }

  /**
   * 密码显示
   * @param entity 银行信息
   */
  function mmshow(entity) {
    var yhmmshow = false; // 银行密码显示
    var zjmmshow = false; // 资金密码显示

    // 银行转证券
    if (zhlx == "1") {
      yhmmshow = entity.zrmmpz == "2" || entity.zrmmpz == "3" ? true : false;

      zjmmshow = entity.zrmmpz == "1" || entity.zrmmpz == "3" ? true : false;
    }
    // 证券转银行
    else {
      yhmmshow = entity.zcmmpz == "2" || entity.zcmmpz == "3" ? true : false;

      zjmmshow = entity.zcmmpz == "1" || entity.zcmmpz == "3" ? true : false;
    }

    return {
      "yhmmshow": yhmmshow,
      "zjmmshow": zjmmshow
    }
  }
});

/*=========================================
  函数功能：把下拉框里的值显示出来
  入参说明：obj 选中的对象
=========================================*/
function setDivselectValue(obj) {
  var in_modal = obj.parent().attr("in_modal");
  var hid_modal = obj.parent().attr("hid_modal");

  if (in_modal != undefined && in_modal != "") {
    $("#" + in_modal).val(obj.find("label").text());
  }

  if (hid_modal != undefined && hid_modal != "") {
    $("#" + hid_modal).val(obj.find("label").attr("value"));
  }
}

// 查询余额按钮显示与隐藏
function cyeShowOrHide(index) {
  if (zhlx == "1") {
    if (dataList[index].yhyemmpz == 4) {
      $("#balance").hide()
    } else {
      $("#balance").show();
    }
  }
}

//获取对应资金账号
function getDYZJZH(dataList) {
  var text = document.getElementById("transaccount_text").value;
  for (var i = 0, len = dataList.length; i < len; i++) {
    if (text == dataList[i].text) {
      return dataList[i].zjzh;
    }
  }
  return dataList[0].zjzh;
}
