var app = angular.module('dtssq', []);

app.controller('dtssqController', function($rootScope, $scope, $compile)
{
    getControllerMethod(null, $scope, null, $compile);

    var now  = new Date();
    var page = getLocalData("page");
    var jjdm = getLocalData("jjdm");
    var jjxq = getLocalData("jjxq");

    $scope.qmtj_show = true;    // 定投-期满条件
    $scope.ksrq_show = true;    // 定投-开始日期
    $scope.zzrq_show = true;    // 定投-终止日期
    $scope.qmcs_show = false;   // 定投-期满次数
    $scope.qmje_show = false;   // 定投-期满金额
    $scope.zebs_show = false;   // 定赎-巨额标识
    $scope.week_show = false;   // 定赎-扣款周期

    // 基金净值/可赎份额
    $scope.jjjz = ["基金净值", "", "元"];
    // 每期定投金额/每期定赎份额
    $scope.mmsl = ["每期定投金额", "", "请输入定投金额", "元"];
    // 基金代码
    $scope.jjdm = "";
    // 基金名称
    $scope.jjmc = "";
    // 基金账号
    $scope.jjzh = "";
    // 收费类别说明
    $scope.sflbsm = "";
    // 申请日期 默认当天, 不可修改
    $scope.sqrq = now.Format("yyyyMMdd");
    // 开始日期 默认当前天
    $scope.ksrq = now.Format("yyyyMMdd");
    // 终止日期 默认30年后的当前天
    now.addYears(30);
    $scope.zzrq = now.Format("yyyyMMdd");
    // 扣款周期/赎回周期 [0]: 显示月 [1]: 显示月 [2]: 周期文本 [3]: 周期值 [4]: 扣款周期/赎回周期
    $scope.active = ["active", "", "每月1号", "01", "扣款周期"];
    // 扣款周期/赎回周期    0:月 1:周
    $scope.kkzq = "0";
    $scope.days = [
        ["1"],["2"],["3"],["4"],
        ["5"],["6"],["7"],["8"],
        ["9"],["10"],["11"],["12"],
        ["13"],["14"],["15"],["16"],
        ["17"],["18"],["19"],["20"],
        ["21"],["22"],["23"],["24"],
        ["25"],["26"],["27"],["28"]
    ];
    $scope.weeks = [["星期一","1"],["星期二","2"],["星期三","3"],["星期四","4"],["星期五","5"]];
    // 扣款日期
    $scope.amountData = [
        ["每月1号", "13", "active"]
    ];

    // 期满条件
    $scope.qmtj = ["0", "日期区间"];
    // 巨额标志
    $scope.jebz = ["0", "取消"];
    // 期满金额
    $scope.qmje = "";
    // 期满次数
    $scope.qmcs = "";

    // 可买卖查询
    $scope.kmmcx = {};
    // 业务类别 定投/定赎
    $scope.sort = page=="定投申请"?"dt":page=="定赎申请"?"ds":"";
    // 操作类型 修改/新增
    $scope.czlx = jjdm != null && jjxq != null ? "update" : "add";
    // 定投金额输入框是否可用
    $scope.isIputDisabled = true;

    // 因为界面默认显示的是定投, 是定赎时需要修改界面的显示内容
    if($scope.sort == "ds") {
        $scope.qmtj_show = false;   // 定投-期满条件
        $scope.qmcs_show = false;   // 定投-期满次数
        $scope.qmje_show = false;   // 定投-期满金额
        $scope.zebs_show = true;    // 定赎-巨额标识
        $scope.week_show = true;   // 定赎-扣款周期
        $scope.active[4] = "赎回周期";
        $scope.jjjz = ["可赎份额", "", "份"];
        $scope.mmsl = ["每期定赎份额", "", "请输入定赎份额", "份"];
    }
    else if($scope.sort == ""){
        console.log("没有申请类型");
        return;
    }

    // 修改操作, 初始化部分数据
    if($scope.czlx == "update") {
        $("#zqdm").attr("disabled", true);
        jjxq = JSON.parse(jjxq);

        order.curzqdm = jjdm;
        dtssqApi.queryJJKMMSLCX(jjdm, $scope.sort, $scope);
        // 显示申请日期/开始日期/终止日期/扣款周期
        $scope.sqrq = jjxq.wtrq;
        $scope.ksrq = jjxq.ksrq;
        $scope.zzrq = jjxq.zzrq;
        $scope.kkzq = $scope.sort=="dt"?jjxq.kkzq:jjxq.shzq;
        // 显示扣款周期/赎回周期
        if($scope.kkzq == "1") {
            $scope.active[0] = "";
            $scope.active[1] = "active";
        }
        $scope.active[2] = $scope.kkzq=="0"?("每月"+jjxq.kkrq+"号"):("每周"+$scope.weeks[jjxq.kkrq-1][0]);
        $scope.active[3] = jjxq.kkrq;
        // 显示金额/份额
        if($scope.sort == "dt") {
            $scope.mmsl[1] = jjxq.wtje;
            // 显示期满条件
            var qmzl = ["日期区间", "期满金额", "期满次数"];
            $scope.qmtj = [jjxq.qmzl, qmzl[jjxq.qmzl]];
            if(jjxq.qmzl == "1") {
                $scope.ksrq_show = false;  // 定投-开始日期
                $scope.zzrq_show = false;  // 定投-终止日期
                $scope.qmje_show = true;   // 定投-期满金额
                $scope.qmje = jjxq.qmcs;
            }
            else if(jjxq.qmzl == "2") {
                $scope.ksrq_show = false;  // 定投-开始日期
                $scope.zzrq_show = false;  // 定投-终止日期
                $scope.qmcs_show = true;   // 定投-期满次数
                $scope.qmcs = jjxq.qmcs;
            }
        }
        else if($scope.sort == "ds") {
            $scope.mmsl[1] = jjxq.jjfe;
        }
    }

    $scope.setActive = function(state) {
        if(state == 0) {
            $scope.active[0] = "active";
            $scope.active[1] = "";
            $scope.kkzq = "0";
        } else {
            $scope.active[0] = "";
            $scope.active[1] = "active";
            $scope.kkzq = "1";
        }
    }

    $scope.setDay = function(value) {
        $scope.active[2] = "每月"+value+"号";
        $scope.active[3] = value;

        setTimeout(function(){
            $("#d-jyrq").find(".dropdown-menu.active").hide();
        }, 100);
    }

    $scope.setWeek = function(value, value2) {
        $scope.active[2] = "每周"+value;
        $scope.active[3] = value2;

        setTimeout(function(){
            $("#d-jyrq").find(".dropdown-menu.active").hide();
        }, 100);
    }

    // 巨额标识下拉框选择事件
    dtssqApi.delegateClick("d-zebs", function(obj){
        console.log("message: d-zebs");
        var v0 = $(obj).attr("value");
        var v1 = $(obj).text();
        $scope.jebz = [v0, v1];

        console.log($scope.jebz);
    });

    // 投资描述下拉框选择事件
    dtssqApi.delegateClick("d-tzms", function(obj){
        console.log("message: d-tzms");
    });

    // 期满条件下拉框选择事件
    dtssqApi.delegateClick("d-qmtj", function(obj){
        console.log("message: d-qmtj ");
        var oText  = $(obj).text();
        var oValue = $(obj).attr("value");
        $scope.qmtj= [oValue, oText];

        $scope.ksrq_show = false;
        $scope.zzrq_show = false;
        $scope.qmcs_show = false;
        $scope.qmje_show = false;

        if(oText == "日期区间") {
            $scope.ksrq_show = true;
            $scope.zzrq_show = true;
        }
        else if(oText == "期满次数") {
            $scope.qmcs_show = true;
        }
        else if(oText == "期满金额") {
            $scope.qmje_show = true;
        }
    });

    $scope.showModal = function() {
        console.log("message: showModal 基金定投/定赎申请或修改");
        // 隐藏自定义键盘
        hideKeyBoard();

        // 表单验证
        if(!dtssqApi.verificationForm($scope, $compile)) {
            return;
        }

        // 定投申请
        if($scope.sort == "dt" && $scope.czlx == "add")  {
            dtssqApi.showModalDTSQ($scope, $compile);
        }
        // 定投修改
        else if($scope.sort == "dt" && $scope.czlx == "update")  {
             dtssqApi.showModalDTXG($scope, $compile, jjxq);
        }
        // 定赎申请
        else if($scope.sort == "ds" && $scope.czlx == "add")  {
            dtssqApi.showModalDSSQ($scope, $compile);
        }
        // 定赎修改
        else if($scope.sort == "ds" && $scope.czlx == "update")  {
            dtssqApi.showModalDSXG($scope, $compile, jjxq);
        }
    }

    $scope.Ensure = function() {
        console.log("message: Ensure 申请确认");

        // 定投申请
        if($scope.sort == "dt" && $scope.czlx == "add")  {
            var checked = $(".dialog-protocol-check input").attr("checked");
            if (!checked) {
                showMessageTips("请阅读《世纪证券金融产品或服务投资者风险揭示书》和《基金产品信息查询指引》后进行勾选", 40);
                return;
            }
            dtssqApi.SDXCX($scope.jjdm, $scope, $compile);
        }
        // 定投修改
        else if($scope.sort == "dt" && $scope.czlx == "update")  {
            dtssqApi.DTXG($scope, $compile, jjxq);
        }
        // 定赎申请
        else if($scope.sort == "ds" && $scope.czlx == "add")  {
            dtssqApi.DSSQ($scope, $compile);
        }
        // 定赎修改
        else if($scope.sort == "ds" && $scope.czlx == "update")  {
            dtssqApi.DSXG($scope, $compile, jjxq);
        }
        CloseModal();
    }

    $scope.showProtocol = function(key) {
        setLocalData("fxjss-from", "kfsjj_jjdt");
        if (key == "fxjss") {
            JumpInterface("kfsjj/xylb/fxjss.html", 8, 1);
        } else if (key == "cxzy") {
            JumpInterface("kfsjj/xylb/cxzy.html", 8, 1);
        }
    }

    document.title = page;
});


var dtssqApi = {
    // 基金可买卖数量查询
    queryJJKMMSLCX: function(jjdm, sort, $scope) {
        var postData = {
            jjgsdm : '',
            jjdm   : jjdm,
            ywlx   : "1",
        };

        ajaxPost(getApiUrl()+"ptjy/cwkfsjj/jjkmmslcx", postData, function(response){
            if(response.cxlb.length == 0) {
                console.log("message: 基金可买卖数量查询查询列表为空!");
                showMessageTips("该基金不存在，请重新输入");
                return;
            }
            //启用定投金额输入框
            $scope.isIputDisabled = false;

            // 显示部分数据
            var bean = response.cxlb[0];
            $scope.kmmcx  = bean;
            $scope.jjdm   = bean.jjdm;
            $scope.jjmc   = bean.jjmc;
            $scope.sflbsm = bean.sflbsm;

            // 基金定投
            if("dt" == sort) {
                $scope.jjjz[1] = bean.jjdwjz;
            }
            // 基金定赎
            else if("ds" == sort) {
                $scope.jjjz[1] = bean.jjkys;
            }
            dtssqApi.queryJJZH($scope, bean.jjgsdm);
        });
    },

    // 查询基金账号
    queryJJZH: function($scope, jjgsdm) {
        ajaxPost(getApiUrl() + "ptjy/cwkfsjj/jjzhcx", {
            jjgsdm: jjgsdm,
            cxfx: "1",
            qqhs: "10",
        }, function(resp) {
            var item = resp.cxlb[0] || {};
            $scope.jjzh = item.jjzh;
        });
    },

    // 定投申请模态框
    showModalDTSQ: function($scope, $compile) {
        if(getLocalData("ptjyAccount") == null) { return;}

        var ptjyAccount = JSON.parse(getLocalData("ptjyAccount"));

        var modal = {};
        modal["title"] = "基金定投申请";
        modal["content"] = [
            {"key": "操作类别",     "value": "基金定投申请"},
            {"key": "基金代码",     "value": $scope.jjdm},
            {"key": "基金名称",     "value": $scope.jjmc+"("+$scope.sflbsm+")"},
            {"key": "基金账号",     "value": $scope.jjzh},
            {"key": "扣款周期",     "value": $scope.active[2]},
            {"key": "期满条件",     "value": $scope.qmtj[1]},
        ];

        // 日期区间
        if($scope.qmtj[0] == "0") {
            modal["content"].push({"key": "开始日期",     "value": $("#ksrq").val()});
            modal["content"].push({"key": "终止日期",     "value": $("#zzrq").val()});
        }
        // 期满次数
        else if($scope.qmtj[0] == "2") {
            modal["content"].push({"key": "期满次数",     "value": $("#qmcs").val()});
        }
        // 期满金额
        else if($scope.qmtj[0] == "1") {
            modal["content"].push({"key": "期满金额",     "value": $("#qmje").val()});
        }

        modal["showProtocol"] = true;
        modal["protocolAccept"] = "我已仔细阅读并同意签署以上各项协议";
        modal["protocolCheck"] = "unchecked";
        modal["protocols"] = [{key: "fxjss", value: "《世纪证券金融产品或服务投资者风险揭示书》"}, {key: "cxzy", value: "《基金产品信息查询指引》"}];
        create_dialog(controller["scope"], controller["compile"], modal);
    },

    // 定投申请
    DTSQ: function($scope, $compile) {
        var url  = "ptjy/cwkfsjj/jjdtsq";
        // 期满参数 [1]:期满金额 [2]:期满次数
        var qmcs = ["", $("#qmje").val(), $("#qmcs").val()];
        var ywlsh = $("#ywlsh").val() ? $("#ywlsh").val() : "";

        var postData = {
            'jjdm': $scope.jjdm,            // Y 基金代码
            'sflb': $scope.kmmcx.sflb,      // Y 收费类别
            'ksrq': $("#ksrq").val(),       // Y 开始日期
            'zzrq': $("#zzrq").val(),       // Y 终止日期
            'kkrq': $scope.active[3],       // Y 扣款日期
            'wtje': $("#price").val(),      // Y 委托金额
            'qmzl': $scope.qmtj[0],         // Y 期满种类   0-日期 2-次数 1-金额
            'qmcs': qmcs[$scope.qmtj[0]],   // Y 期满次数   当期满种类为1,2时,该参数起作用
            'kkzq': $scope.kkzq,            // Y 扣款周期   0-每月 1-每周
            'ywlsh': ywlsh,                 // 业务流水号
        };

        ajaxPost(getApiUrl()+url, postData, function(response){
            $("#ywlsh").val("");
            showAlertMsg("委托提交成功,流水号："+response.htxx[0].wtxh, "提示信息", "确定", false, null, function(){
                clearJJJYForm("zqdm", "whole");
                CloseAlert();
            });
        });
    },

    // 定投修改模态框
    showModalDTXG: function($scope, $compile, jjxq) {
        var modal = {};
        modal["title"] = "基金定投修改";
        modal["content"] = [
            {"key": "操作类别",     "value": "基金定投修改"},
            {"key": "基金代码",     "value": $scope.jjdm},
            {"key": "基金名称",     "value": $scope.jjmc+"("+$scope.sflbsm+")"},
            {"key": "基金账号",     "value": jjxq.jjzh},
            {"key": "扣款周期",     "value": $scope.active[2]},
            {"key": "期满条件",     "value": $scope.qmtj[1]},
        ];

        // 日期区间
        if($scope.qmtj[0] == "0") {
            modal["content"].push({"key": "开始日期",     "value": $("#ksrq").val()});
            modal["content"].push({"key": "终止日期",     "value": $("#zzrq").val()});
        }
        // 期满次数
        else if($scope.qmtj[0] == "2") {
            modal["content"].push({"key": "期满次数",     "value": $("#qmcs").val()});
        }
        // 期满金额
        else if($scope.qmtj[0] == "1") {
            modal["content"].push({"key": "期满金额",     "value": $("#qmje").val()});
        }

        create_modal($scope, $compile, modal);
    },

    // 定投修改
    DTXG: function($scope, $compile, jjxq) {
        var url  = "ptjy/cwkfsjj/jjdtxg";
        // 期满参数 [1]:期满金额 [2]:期满次数
        var qmcs = ["", $("#qmje").val(), $("#qmcs").val()];

        var postData = {
            'jjdm': $scope.jjdm,            // Y 基金代码
            'sflb': $scope.kmmcx.sflb,      // Y 收费类别
            'ksrq': $("#ksrq").val(),       // Y 开始日期
            'zzrq': $("#zzrq").val(),       // Y 终止日期
            'kkrq': $scope.active[3],       // Y 扣款日期
            'wtje': $("#price").val(),      // Y 委托金额
            'qmzl': $scope.qmtj[0],         // Y 期满种类   0-日期  1-金额 2-次数
            'qmcs': qmcs[$scope.qmtj[0]],   // Y 期满次数   当期满种类为1,2时,该参数起作用
            'kkzq': $scope.kkzq,            // Y 扣款周期   0-每月 1-每周
            'wtrq': jjxq.wtrq,              // N 委托日期
            'lsh' : jjxq.lsh,               // N 流水号
            'wtbh': jjxq.wtbh,              // N 委托编号
        };

        ajaxPost(getApiUrl()+url, postData, function(response){
            showAlertMsg("委托提交成功,流水号："+response.htxx[0].wtxh, "提示信息", "确定", false, null, function(){
                clearJJJYForm("zqdm", "whole");
                CloseAlert();
            });
        });
    },

    // 定赎申请模态框
    showModalDSSQ: function($scope, $compile) {
        if(getLocalData("ptjyAccount") == null) { return;}

        var ptjyAccount = JSON.parse(getLocalData("ptjyAccount"));

        var modal = {};
        modal["title"] = "基金定赎申请";
        modal["content"] = [
            {"key": "操作类别",     "value": "基金定赎申请"},
            {"key": "基金代码",     "value": $scope.jjdm},
            {"key": "基金名称",     "value": $scope.jjmc+"("+$scope.sflbsm+")"},
            {"key": "基金账号",     "value": $scope.jjzh},
            {"key": "赎回周期",     "value": $scope.active[2]},
            {"key": "周期赎回份额", "value": $("#price").val()},
            {"key": "开始日期",     "value": $("#ksrq").val()},
            {"key": "终止日期",     "value": $("#zzrq").val()},
            {"key": "巨额标志",     "value": $scope.jebz[1]},
        ];

        create_modal($scope, $compile, modal);
    },

    // 定赎申请
    DSSQ: function($scope, $compile) {
        var url  = "ptjy/cwkfsjj/jjdssq";

        var postData = {
            'jjdm': $scope.jjdm,            // Y 基金代码
            'sflb': $scope.kmmcx.sflb,      // Y 收费类别
            'ksrq': $("#ksrq").val(),       // Y 开始日期
            'zzrq': $("#zzrq").val(),       // Y 终止日期
            'kkrq': $scope.active[3],       // Y 扣款日期
            'wtsl': $("#price").val(),      // Y 委托数量
            'shzq': $scope.kkzq,            // Y 赎回周期   0-每月 1-每周
            'kkzq': "0",                    // Y 扣款周期   0-每月 1-每周
            'jebz': $scope.jebz[0],         // Y 巨额标志   0-取消 1-顺延
        };

        ajaxPost(getApiUrl()+url, postData, function(response){
            showAlertMsg("委托提交成功,流水号："+response.htxx[0].wtxh, "提示信息", "确定", false, null, function(){
                clearJJJYForm("zqdm", "whole");
                CloseAlert();
            });
        });
    },

    // 定投修改模态框
    showModalDSXG: function($scope, $compile, jjxq) {
        var modal = {};
        modal["title"] = "基金定赎修改";
        modal["content"] = [
            {"key": "操作类别",     "value": "基金定赎修改"},
            {"key": "基金代码",     "value": $scope.jjdm},
            {"key": "基金名称",     "value": $scope.jjmc+"("+$scope.sflbsm+")"},
            {"key": "基金账号",     "value": jjxq.jjzh},
            {"key": "赎回周期",     "value": $scope.active[2]},
            {"key": "每期赎回份额", "value": $("#price").val()},
            {"key": "开始日期",     "value": $("#ksrq").val()},
            {"key": "终止日期",     "value": $("#zzrq").val()},
            {"key": "巨额标志",     "value": $scope.jebz[1]},
        ];

        create_modal($scope, $compile, modal);
    },

    // 定赎修改
    DSXG: function($scope, $compile, jjxq) {
        var url  = "ptjy/cwkfsjj/jjdsxg";

        var postData = {
            'jjdm': $scope.jjdm,            // Y 基金代码
            'sflb': $scope.kmmcx.sflb,      // Y 收费类别
            'ksrq': $("#ksrq").val(),       // Y 开始日期
            'zzrq': $("#zzrq").val(),       // Y 终止日期
            'kkrq': $scope.active[3],       // Y 扣款日期
            'wtsl': $("#price").val(),      // Y 委托数量
            'shzq': $scope.kkzq,            // Y 赎回周期   0-每月 1-每周
            'kkzq': "0",                    // Y 扣款周期
            'jebz': $scope.jebz[0],         // Y 巨额标志   0-取消 1-顺延
            'wtrq': jjxq.wtrq,              // N 委托日期
            'lsh' : jjxq.lsh,               // N 流水号
            'wtbh': jjxq.wtbh,              // N 委托编号
        };

        ajaxPost(getApiUrl()+url, postData, function(response){
            showAlertMsg("委托提交成功,流水号："+response.htxx[0].wtxh, "提示信息", "确定", false, null, function(){
                clearJJJYForm("zqdm", "whole");
                CloseAlert();
            });
        });
    },

    /****************** 绑定事件 **********************/
    delegateClick: function(selectId, handler) {
        $(document).delegate("#"+selectId+" .dropdown-menu > li","click",function() {
            $("#"+selectId+" .dropdown-menu li").each(function() {
                if($(this).hasClass("active")) {
                    $(this).removeClass("active");
                }
            })
            // 设置选中样式
            if($(this).hasClass("active") == false) {
                $(this).addClass("active");
            }
            // 设置选中值
            $("#"+selectId+" button").text($(this).text());
            // 隐藏父div
            $(this).parent().hide();

            var obj = this;
            angular.element($("body")).scope().$apply(function(){
                // 执行回调函数
                handler(obj);
            });

            // 点击事件禁止冒泡传播
            return false;
        })
    },

    // 验证表单
    verificationForm: function($scope, $compile) {
        var $zqdm   = $("#zqdm");
        var $price  = $("#price");
        var $ksrq   = $("#ksrq");
        var $zzrq   = $("#zzrq");
        var $qmcs   = $("#qmcs");
        var $qmje   = $("#qmje");

        if($zqdm.val().trim().length < 6) {
            $zqdm.focus();
            return false;
        }
        else if($price.val().trim().length == 0) {
            $price.focus();
            return false;
        }
        else if($ksrq.val().trim().length == 0) {
            $ksrq.focus();
            return false;
        }
        else if($zzrq.val().trim().length == 0) {
            $zzrq.focus();
            return false;
        }
        // 期满金额
        if($scope.qmtj[0] == "1" && $qmje.val().trim().length == 0) {
            $qmje.focus();
            return false;
        }
        // 期满次数
        if($scope.qmtj[0] == "2" && $qmcs.val().trim().length == 0) {
            $qmcs.focus();
            return false;
        }

        return true;
    },

    /**
    * 场外产品适当性查询
    */
    SDXCX: function(jjdm, $scope, $compile) {
        ajaxPost(getApiUrl() + "ptjy/zhyw/cwcpsdxcx", {
            jjdm: jjdm,
            jyxw: "1",
        }, function(response){
            var cxlb = response.cxlb || [];
            var xylb = response.xylb || [];
            if (cxlb.length > 0) {
                cxlb = cxlb[0];
                var xtrq = cxlb.xtrq;
                var xtrqDate = xtrq ? new Date(parseInt(xtrq.substr(0, 4)), parseInt(xtrq.substr(4, 2)) - 1, parseInt(xtrq.substr(6, 2))) : new Date();
                var zytzzyxq = cxlb.zytzzyxq;
                var yxqDate = zytzzyxq ? new Date(parseInt(zytzzyxq.substr(0, 4)), parseInt(zytzzyxq.substr(4, 2)) - 1, parseInt(zytzzyxq.substr(6, 2))) : new Date();

                if (cxlb.zytzzbz != "0" && yxqDate >= xtrqDate) { //判断是否为专业投资者，需在有效期内才是。0-普通投资者 1-专业投资者;
                    //专业投资者 继续交易
                    dtssqApi.DTSQ($scope, $compile);
                } else {
                    if (cxlb.zdfxcsnlbz != "1") { //判断是否为最低风险承受能力标识 0-否，1-是
                        //检查适当性是否匹配
                        dtssqApi.checkSDXMatch(jjdm, cxlb, $scope, $compile)
                    } else {
                        //判断是否未低风险产品
                        if (cxlb.cpfxdj == "0") {
                            //检查适当性是否匹配
                            dtssqApi.checkSDXMatch(jjdm, cxlb, $scope, $compile);
                        } else {
                            //最低风险等级不允许购买不匹配产品
                            showAlertMsg("最低风险等级不允许购买不匹配产品", "提示", "确定", false, "", function(){
                                CloseAlert();
                                clearJJJYForm("zqdm","whole");
                            });
                        }
                    }
                }
            } else {
              dtssqApi.DTSQ($scope, $compile);
            }
        });
    },

    /**
    * 检查适当性是否匹配
    */
    checkSDXMatch: function(jjdm, cxlb, $scope, $compile){
        if (cxlb.sdxppbz != "0" || cxlb.xtrq > cxlb.fxcpyxq) { //判断适当性是否匹配。0-匹配、且未过期
            if (cxlb.sdxppbz == "2" || cxlb.xfxcpbz == "1") { //2-投资者适当性未评测，xfxcpwcbz：1-未测评，其它已测评
                showAlertMsg("尊敬的客户：您好！\n\t我司自2017年7月1日起执行新的客户适当性标准，请进行新的风险承受能力测评。", "提示", "立即测评", true, "不买了", function(){
                    //跳转到测评页面
                    JumpInterface(params.viewKey.KDS_DZQY_FXCP_START, 8, 0);
                });
            } else if (cxlb.xtrq > cxlb.fxcpyxq) { //1-已过期
                var yxrq = cxlb.fxcpyxq.substr(0, 4) + "-" + cxlb.fxcpyxq.substr(4, 2) + "-" + cxlb.fxcpyxq.substr(6, 2);
                showAlertMsg("尊敬的客户：您好！\n\t您的账户风险测评于" + yxrq + "已过期，请重新进行风险测评。", "提示", "重新测评", true, "不买了", function(){
                    //跳转到测评页面
                    JumpInterface(params.viewKey.KDS_DZQY_RISK_RESULT, 8, 0);
                });
            } else {
                var fxjss = dtssqApi.dealFXJSS(cxlb);
                //显示不匹配风险揭示书
                showAlertMsg("<div class='fxjss'>" + fxjss + "</div>", "", "确认签署", true, "不买了", function(){
                    CloseAlert();
                    dtssqApi.SDXLH(jjdm, "", cxlb.xyid, cxlb.xylx, $scope, $compile);
                }, function(){
                    CloseAlert();
                    clearJJJYForm("zqdm","whole");
                }, true);
            }
        } else {
            var fxjss = dtssqApi.dealFXJSS(cxlb);
            //显示不匹配风险揭示书
            showAlertMsg("<div class='fxjss'>" + fxjss + "</div>", "", "确认签署", true, "不买了", function(){
                CloseAlert();
                dtssqApi.SDXLH(jjdm, "", cxlb.xyid, cxlb.xylx, $scope, $compile);
            }, function(){
                CloseAlert();
                clearJJJYForm("zqdm","whole");
            }, true);
        }
    },

    /**
    * 适当性留痕
    */
    SDXLH: function (jjdm, jysdm, xyid, xylx, $scope, $compile){
        ajaxPost(getApiUrl() + "ptjy/zhyw/sdxlh", {
            xtbs: "1", //"0-场内，1-场外"
            cpdm: jjdm,
            jysdm: jysdm,
            xyid: xyid,
            xylx: xylx,
        }, function(response){
            var cxlb = response.cxlb || [];
            if (cxlb.length > 0) {
                cxlb = cxlb[0];
                var lhlsh = cxlb.lhlsh;
                $("#ywlsh").val(lhlsh);
                dtssqApi.DTSQ($scope, $compile);
            }
        });
    },

    /**
    * 处理返回的风险揭示书，替换相关字段
    */
    dealFXJSS: function (cxlb){
        var fxjss = cxlb.fxjss;
        var date = cxlb.xtrq;
        date = date ? (date.substr(0, 4) + "-" + date.substr(4, 2) + "-" + date.substr(6, 2)) : "";
        var user = JSON.parse(getLocalData("ActivePTJYUser"))["body"]["dlxx"][0];
        fxjss = fxjss.replace(/{{name}}/g, user.khxm).replace(/{{takeRisk}}/g, cxlb.khfxdjsm)
            .replace(/{{product}}/g, cxlb.jjmc).replace(/{{riskLevel}}/g, cxlb.cpfxdjsm)
            .replace(/{{account}}/g, user.khdm).replace(/{{service}}/g, cxlb.jjmc)
            .replace(/{{company}}/g, cxlb.yybjc).replace(/{{date}}/g, date);
        return fxjss;
    }
}

/**
* 弹出框协议确认事件
*/
function onProtocolCheck(){
    if ($(".dialog-protocol-check input").attr("checked")) {
        $(".dialog-protocol-check input").attr("class", "unchecked");
        $(".dialog-protocol-check input").attr("checked", false);
    } else {
        $(".dialog-protocol-check input").attr("class", "checked");
        $(".dialog-protocol-check input").attr("checked", true);
    }
}

function Back() {
    $("#CustomAlert").remove();
}

/*======================================
函数功能:     清除基金交易表单
传入参数: jjdm:代码名称 param: 是否全部清空
=======================================*/
function clearJJJYForm(jjdm, param) {
    if( jjdm == "zqdm" ) {
        $("#zqdm").val("");
        $("#price").val("");
        angular.element($("body")).scope().$apply(function(){
            var $scope = controller.scope;
            $scope.jjdm = "";
            $scope.jjmc = "";
            $scope.sflbsm = "";
            $scope.jjjz[1] = "";
            $scope.mmsl[1] = "";
            // $scope.active[2] = "";
        });
    }
}

// APP 自定义键盘回调函数
function fillInputContent(param) {
    var $inId = $("#"+params.id);
    if(param == "del") {
        var _value = $inId.val();
        if(_value.length > 0) {
            _value = _value.substring(0,_value.length-1);
            $inId.val(_value);
        }
    }
    else {
        // 输入小数点合法性判断
        if( params.id == "price" ) {
            var value = $inId.val() + param;
            if (value && value.indexOf(".") > -1 && value.substr(value.indexOf(".") + 1).length > 2) {
                return;
            }
            $inId.val(value);
        }
        else if( params.id == "zqdm" || params.id == "zrzqdm" ) {
            if($inId.val().length < 6) {
                $inId.val($inId.val()+param);
                if ($inId.val().length == 6) {
                    order.curzqdm = $inId.val();
                    // 基金代码位数达到 6 位, 进行基金可买卖数量查询
                    dtssqApi.queryJJKMMSLCX($inId.val(), controller.scope.sort, controller.scope);
                }
            }
        }
        else {
            $inId.val($inId.val()+param);
        }
    }
}
