//风险测评答题
var app = angular.module("dzqyRiskEvaluation", []);

app.controller("dzqyRiskEvaluationController", ["$scope", "QuestionList", function (scope, questionList) {
    var data = requestQuestions(scope, questionList);

    scope.btnDisabled = false;

    scope.onCellCheck = function (item, index) {
        // 客观题不容许手动改变答案
        if (item.banCheck) {
            return;
        }
        var styles = questionList.styles;
        var checkInfo = item.checkInfo;
        var list = item.list;
        var styleIndex = item.isMultiple ? 1 : 0;
        if (item.isMultiple) {
            checkInfo[index] = !checkInfo[index];
        } else {
            checkInfo[index] = true;
            //将其他制为不选
            for (var i = 0; i < list.length; i++) {
                if (i != index) {
                    list[i].style = styles[styleIndex][0];
                    checkInfo[i] = false;
                }
            }
        }
        list[index].style = styles[styleIndex][checkInfo[index] == true ? 1 : 0];
    };

    //提交数据
    scope.onBtnClick = function () {
        var data = scope.data;
        var checkInfo;
        var isAllAnswer;
        for (var i = 0; i < data.length; i++) {
            checkInfo = data[i].checkInfo;
            isAllAnswer = false;
            for (var j = 0; j < checkInfo.length; j++) {
                if (checkInfo[j] == true) {
                    isAllAnswer = true;
                    break;
                }
            }
            if (!isAllAnswer) {
                showAlert("第 " + data[i].itemId + " 题没有回答，请回答后提交。", "提示")
                return;
            }
        }

        var result = getSubmitData(questionList);
        scope.btnDisabled = true;
        submitAnswers(result, scope);
    };

    scope.$watch('$viewContentLoaded', function () {
        var totalHeight = document.documentElement.clientHeight;
        var bottomHeight = document.getElementById("buttomButton").clientHeight;
        scope.topHeightStyle = "height:" + (totalHeight - bottomHeight) + "px";
    });
}]);

app.service("QuestionList", ["$rootScope", function (rootScope) {
    var styles = [["inputSingleUnselected", "inputSingleSelected"],
        ["inputMultipleUnselected", "inputMultipleSelected"]];
    var service = {
        data: [],
        dic: {},
        styles: styles
    };
    return service;
}]);

//获取提交数据
function getSubmitData(questionList) {
    console.log(questionList);
    var dic = questionList.dic;
    var value = questionList.data;
    var numStr = "", selectedStr = "", scoreStr = "", idStr = "";
    var checkInfo, scoreArr, data, list;
    var tempJ = -1;
    var finalScore = 0;
    for (var i = 0, len = value.length; i < len; i++) {
        data = value[i];
        idStr += data.stid;
        numStr += data.itemId;
        checkInfo = data.checkInfo;
        scoreArr = dic[data.itemId].score;
        list = data.list;
        tempJ = -1;
        for (var j = 0, jLen = checkInfo.length; j < jLen; j++) {
            if (checkInfo[j] == true) {
                if (tempJ != -1) {
                    selectedStr += ",";
                    scoreStr += ",";
                }
                selectedStr += list[j].wordIndex;
                scoreStr += scoreArr[j];
                finalScore += parseInt(scoreArr[j]);
                tempJ = j;
            }
        }
        if (i != len - 1) {
            idStr += "|";
            numStr += "|";
            selectedStr += "|";
            scoreStr += "|";
        }
    }
    return {numStr: numStr, selectedStr: selectedStr, scoreStr: scoreStr, finalScore: finalScore, idStr: idStr, dcblz: questionList.dcblz};
};

//请求试题
function requestQuestions(scope, questionList) {
    var user = JSON.parse(getLocalData("ActivePTJYUser"))["body"]["dlxx"][0];
    var khsx = user.khsx || "";
    var khh = user.khdm || "";
    //客户属性（“0”：个人  “1”：机构）
    var cpdcbbh = khsx== "1" ? "8" : "7";
    ajaxPost(getApiUrl() + "ptjy/zhyw/hqfxcpst", {tmlb: cpdcbbh, khsx: khsx, khh: khh}, function(response){
        var stlb = response.stlb || [];
        for (var key in stlb) {
            stlb[key].xxnr = stlb[key].xxnr.replace(/≤/g, "＜=");
            stlb[key].xxnr = stlb[key].xxnr.replace(/≥/g, "＞=");
        }
        var info = dealQuestion(stlb, questionList.styles);

        questionList.data = info.result;
        questionList.dic = info.dic;
        questionList.dcblz = info.dcblz;
        scope.data = info.result;
    })
}

function dealQuestion(questions, styles){
    var result = [], dic = {}, dcblz = "";
    var item, list, score, checkInfo, index, multipleIntValue;
    for (var i = 0, len = questions.length; i < len; i++) {
        que = questions[i];
        item = dic[que.tmbh];
        if (!item) {
            item = {
                stid: que.stid,
                itemId: que.tmbh,//题目Z编号
                title: que.tmbh + "、" + que.stnr,//题目内容
                isMultiple: "1" == que.xxlx.toString() ? true : false, //单选多选(0:单选 1:多选)
                banCheck: que.zkg === '0' ? true : false,   //客观题
            }
            index = 0;
            result.push(item);
            dic[que.tmbh] = item;
            item.list = list = [];
            item.score = score = [];
            item.checkInfo = checkInfo = [];
            multipleIntValue = item.isMultiple ? 1 : 0;
        }
        var kgtIndex = (que.zkg === '0' && que.kgtda === que.xxbh) ? 1 : 0;
        score.push(que.xxdf);
        if (que.kgtda === que.xxbh) {
            checkInfo.push(true);
        } else {
            checkInfo.push(false);
        }
        list.push({
            index: index,
            wordIndex: que.xxbh,
            name: que.xxbh.toUpperCase() + " " + que.xxnr,
            remark: que.remark,
            style: styles[multipleIntValue][kgtIndex]
        });
        dcblz = que.stlz;
        index++;
    }
    return {result: result, dic: dic, dcblz: dcblz};
}

//提交答案
function submitAnswers(result, scope) {
    var user = JSON.parse(getLocalData("ActivePTJYUser"))["body"]["dlxx"][0];
    var khsx = user.khsx || "";
    var khh = user.khdm || "";
    //客户属性（“0”：个人  “1”：机构）
    var cpdcbbh = khsx == "1" ? "8" : "7";
    var param = {
        dcbbm: cpdcbbh,
        dcblz: result.dcblz,
        dcblmid: result.idStr,
        dcblm: result.numStr,
        dcbdy: result.selectedStr,
        khh: khh,
    };
    ajaxPost(getApiUrl() + "ptjy/zhyw/fxcpdt", param, function(response){
        var fhxx = response.fhxx || [];
        if (fhxx.length > 0) {
            var info = fhxx[0];
            var key = "dzqy-evluation-score";
            var data = {khfxdj: info.pjjb, khfxdjsm: info.pjjbmc, cpdf: info.jcfz, cprq: info.pjrq, yybjc: info.yybjc};
            setLocalData(key, data)
            JumpInterface("ptjy/dzqy/fxcp/fxcp_jggzs.html", 8, 0);
        }
    }, null, {loadMsg: "正在上传您的测评信息，请稍后...", completeMethod: function(){
        angular.element($("body")).scope().$apply(function() {
            scope.btnDisabled = false;
        });
    }});

};

