var app = angular.module('dbls', []);

app.controller('dblsController', function($rootScope, $scope, $http, $compile)
{
	getControllerMethod($rootScope, $scope, $http,$compile);

	//请求参数
	var request = {qsrq:"",zzrq:""};

	//tab选项卡的索引值
	var tab_index = 0;

	//没有调拨流水,页面显示的提示信息
	var isEmpty_msg = ["您今天没有调拨流水记录","您这个月没有调拨流水记录","您3个月内没有调拨流水记录"];

	loading("drzjhblscx", 0);

	/*======================================
		页面列表数据动态加载
	======================================*/
	function loading(businessName, tab_index)
	{
		// 当日资金划拨流水查询
		if(businessName == "drzjhblscx")
		{
			request = { cxfx: "1", qqhs: "999", dwc: "" };
			var lastUrl = "ptjy/yzzz/drzjhblscx";
		}
		// 历史资金划拨流水查询
		else if(businessName == "lszjhblscx")
		{
			var lastUrl = "ptjy/yzzz/lszjhblscx";
		}
		else
		{
			return;
		}

		$scope.hide_cls = false;

		ajaxPost(getApiUrl()+lastUrl,request,function(response)
		{
			if(response.cxlb == undefined || response.cxlb.length == 0 )
			{
				$scope.IsEmpty  = isEmpty_msg[tab_index];
				$scope.hide_cls = true;
			}

			// 对返回数据中的列表数据进行非空处理
			formatResponseData(response);

			for(var i in response.cxlb)
			{
				response.cxlb[i].zzje = formatNumber(response.cxlb[i].zzje);
				response.cxlb[i]['zjzh'] = response.cxlb[i].ywmc == "--" || response.cxlb[i].ywmc == "调入" ? response.cxlb[i].zrzjzh : response.cxlb[i].zczjzh;

				// 时间格式化
				response.cxlb[i]["zzsj"] = formatDate(response.cxlb[i]["zzsj"], "dd:mm:ss");
 			}

			$scope.dblslist = response.cxlb;
		});

	}

	/*==============================================
	函数功能:      动态改变点击标签的样式
	传入参数:      obj：需要改变样式的对象
	===============================================*/
	function changeStyle(obj) {
		//==============判断传入的对象是否为空=============
		//==========未切换标签时,不改变标签样式============
		if (obj == "") {
	    	return;
		}
		//===========点击了当日,一个月内,半年内标签================
		else if (obj.parent().parent().parent().attr("id") == "queryDate") {
	    	$("#queryDate > tbody > tr > td").removeClass("active");
	    	obj.addClass("active");
		}
	}


	//=====================当日,一月内, 半年内 标签页切换=======================
	$("#queryDate > tbody > tr > td").click(function(){
		//获取选中的时间段
		var selectDate = trim($(this).find("a").text());

		changeStyle($(this));

		//弹出自定义查询时间框（间隔不能超过两个月）
		if (selectDate == "»") {
	    	queryObj = this;
	    	addQueryDateSettingView(); //添加自定义时间设置框到界面
	    	return;
		}
		//===========当日委托查询========================
		else if (selectDate == "当日") {
	    	loading("drzjhblscx", 0);
		} //获取近一个月的起始查询日期
		else if (selectDate == "一个月内") {
	    	var now = new Date();
	    	request.zzrq = now.Format("yyyyMMdd");
	    	now.addMonths(-1);
	    	request.qsrq = now.Format("yyyyMMdd");

	    	loading("lszjhblscx", 1);
		} //===========历史委托查询========================
		else if (selectDate == "三个月内") {
	    	var now = new Date();
	    	request.zzrq = now.Format("yyyyMMdd");
	    	now.addMonths(-3);
	    	request.qsrq = now.Format("yyyyMMdd");

	    	loading("lszjhblscx", 2);
		}
	  	return false;
	});

});

//自定义时间日期查询请求
function queryForDate(args){
	var customDate = args instanceof Array ? args : null;
	var request = {
		qsrq: "",
		zzrq: "",
		cxfx: "1",
		qqhs: "999",
		dwc: "",
	};
	var columnNames = ["zzrq", "zzsj", "ywmc", "zzje", "hbmc", "zjzh"];
	if (customDate) { //从选择框自定义了时间
    	request.qsrq = customDate[0];
    	request.zzrq = customDate[1];
    	ajaxPost(getApiUrl() + "ptjy/yzzz/lszjhblscx",request,function(response){
		    if(response.cxlb == undefined || response.cxlb.length == 0 )
			{
				controller["scope"].hide_cls = true;
			}

			// 对返回数据中的列表数据进行非空处理
			formatResponseData(response);

			for(var i in response.cxlb)
			{
				response.cxlb[i].zzje = formatNumber(response.cxlb[i].zzje);
				response.cxlb[i]['zjzh'] = response.cxlb[i].ywmc == "--" || response.cxlb[i].ywmc == "调入" ? response.cxlb[i].zrzjzh : response.cxlb[i].zczjzh;

				// 时间格式化
				response.cxlb[i]["zzsj"] = formatDate(response.cxlb[i]["zzsj"], "dd:mm:ss");
 			}
		    controller["scope"].dblslist = response.cxlb;
    	});
	}
}
