var app = angular.module('zjdb', []);

app.controller('zjdbController', function($rootScope, $scope, $http,$compile)
{
	//从本地存储里接收上一个页面传过来的数据
	var dataList 				= JSON.parse(getLocalData("dataList"));
	//所有数据列表
	$scope.zjzhlist 			= [dataList[1]];				//转出列表
	$scope.zjzhlist_zr 		    = [dataList[0]];				//转入列表
    // 转出账户右边银行 LOGO 显示
    $scope.zc_yh_img = checkyhdm($scope.zjzhlist[0].yhdm);
    // 转入账户右边银行 LOGO 显示
    $scope.zr_yh_img = checkyhdm($scope.zjzhlist_zr[0].yhdm);
	//可转出金额
	$scope.kzcje 				= "可转 " + formatNumber($scope.zjzhlist[0].zjkqs) + params['bzmc'][$scope.zjzhlist[0].hbdm];

	//按钮类型	1：温馨提示	2、调拨确认	3、提示
	var btn_type 				= 0;

	loading();

	/*====================================================
    触发条件：页面加载后执行
    执行功能：加载转出账户与转出账户下拉框列表数,且设置默认值
  ====================================================*/
	function loading()
	{
        // 下拉框显示的文本(组合)
        $scope.zjzhlist[0]['text'] = $scope.zjzhlist[0].zjzh + " " + ($scope.zjzhlist[0].zcbz == "0" ? "(主)" : "(辅)");
        $scope.zjzhlist_zr[0]['text'] = $scope.zjzhlist_zr[0].zjzh + " " + ($scope.zjzhlist_zr[0].zcbz == "0" ? "(主)" : "(辅)");
	}

	/*====================================================
    触发条件：转出账户下拉框change事件
    执行功能：1、切换右边显示的银行图标
    					2、动态显示可转出金额
  ====================================================*/
	$scope.selectChange = function()
	{
		var zjzh = $scope.zjzhlist[$("#sel_zczh").val()];
		$scope.zc_yh_img =  checkyhdm(zjzh.yhdm);
		$scope.kzcje = "可转 " + formatNumber(zjzh.zjkqs) + params['bzmc'][zjzh.hbdm];
	}

	/*====================================================
    触发条件：转入账户下拉框change事件
    执行功能：切换右边显示的银行图标
    ====================================================*/
	$scope.selectChange2 = function()
	{
		var zjzh = $scope.zjzhlist_zr[$("#sel_zrzh").val()];
		$scope.zr_yh_img =  checkyhdm(zjzh.yhdm);
	}

	/*====================================================
    触发条件：点击页面切换按钮
    执行功能：转出账户与转入账户互换
  ====================================================*/
	$scope.zhqh = function()
	{
        var temp = $scope.zjzhlist;

        $scope.zjzhlist = $scope.zjzhlist_zr;
        $scope.zjzhlist_zr = temp;

        var zjzh_temp = $scope.zjzhlist[0];
        $scope.kzcje = "可转 " + formatNumber($scope.zjzhlist[0].zjkqs) + params['bzmc'][$scope.zjzhlist[0].hbdm];
	}

	/*====================================================
    触发条件：点击页面确认按钮
    执行功能：1、验证转出账户与转入账户的资金账号是否相同
    					2、验证转出账户与转入账户的币种是否相同
    					3、验证是否输入金额
    					4、验证金额格式是否正确
    					5、资金划拨
  ====================================================*/
	$scope.bankTrans = function()
	{
		// 转出金额
		var zcje = $("#zcje").val();

		if($scope.zjzhlist[0].zjzh == $scope.zjzhlist_zr[0].zjzh)
		{
			btn_type = 1;
			showModal("转出账号和转入账号不能相同");
			return;
		}
		else if($scope.zjzhlist[0].hbdm != $scope.zjzhlist_zr[0].hbdm)
		{
			btn_type = 1;
			showModal("转出账户和转入账户必须是相同币种");
			return;
		}
		else if(zcje.length == 0)
		{
			btn_type = 1;
			showModal("请输入您要转出的金额");
			return;
		}
		else if(!CheckMoney(zcje))
		{
			btn_type = 1;
			showModal("请输入正确的金额");
			return;
		}
		else
		{
			btn_type = 2;
			showModal(zcje);
			return;
		}
	}

	/*====================================================
    函数功能：验证银行代码在系统配置是否存在(主流银行)
    					存在：	使用该银行代码
    					不存在：返回 “00” (银联)
  ====================================================*/
	function checkyhdm(yhdm)
	{
		for(var i = 0; i < params.yhdms.length; i++)
		{
			if(yhdm == params.yhdms[i]) return yhdm;
		}
		return '00';
	}

	/*====================================================
    函数功能：显示弹出框
  ====================================================*/
	function showModal(obj)
	{
		var modal = {};

		if(btn_type == 1)
		{
			showMessageTips(obj);
			return;
		}
		else if(btn_type == 2)
		{
			var zczh = $scope.zjzhlist[0];
			var zrzh = $scope.zjzhlist_zr[0];

			modal['title'] 	 = "调拨确认";//modal.content/modal.single/modal.msg/modal.inputbox
			modal['content'] = [
				{ key: "转出账户：", value:zczh.text },
				{ key: "转入账户：", value:zrzh.text },
				{ key: "转出金额：", value: formatNumber(obj) }
			];

			if(zczh.mmpz == "1" || zczh.mmpz == "3")
			{
				modal['inputbox']	= [{ id: "zjmm", key: "资金密码", value: "请输入资金密码" }];
			}

			// 创建模态框
            create_modal($scope, $compile, modal, false);
		}
		else if(btn_type == 3)
		{
			modal['title'] = "提示";
            modal['msg'] = [{value:obj}];

            // 创建模态框
            create_modal($scope, $compile, modal, true);
		}
	}

	//====================模态框确认按钮触发事件=============================
    $scope.Ensure = function()
    {
        if(btn_type == 1)
        {
            CloseModal();
        }
        else if(btn_type == 2)
        {
            var zczh = $scope.zjzhlist[$("#sel_zczh").val()];				// 转出账户选中的账户
            var zrzh = $scope.zjzhlist_zr[$("#sel_zrzh").val()];			// 转入账户选中的账户

            if(zczh.mmpz == "1" || zczh.mmpz == "3")
            {
                var zjmm = $("#zjmm").val();

                if(zjmm.length == 0)
                {
                    showMessageTips("请输入资金密码");
                    return;
                }
            }

			//入参：资金划拨	转出资金账号 / 转出资金密码 / 转入资金账号 / 货币代码 / 转出金额 /
			var zjhz_request 		= {
				zczjzh: zczh.zjzh,
				zczjmm: zjmm || "",
				zrzjzh: zrzh.zjzh,
				hbdm 	: zczh.hbdm,
				zcje 	: $("#zcje").val()
			};

            CloseModal();

            ajaxPost(getApiUrl()+"ptjy/yzzz/zjhz",zjhz_request,function(response)
            {
                btn_type = 3;
                showModal(params.message.zjhz_success);
            });
        }
        else if(btn_type == 3)
        {
            // 关闭模态框
            CloseModal();

            // 跳转页面, 返回资金归集页面
            JumpInterface(params.viewKey.KDS_PTJY_ZJDD, 4, -1);
        }
    }

  /*===========================
    显示APP自定义键盘
  ============================*/
  $scope.showKeyboard = function(id)
  {
    showKeyboard(id,'3');
  }
});
