var app = angular.module('zjgj', []);

app.controller('zjgjController', function($rootScope, $scope, $http,$compile)
{
  $scope.userAgent = navigator.userAgent;
  //按钮类型  1：一键归集  2：归集
  var btn_type        = 0;
  //一键归集是否需要资金密码
  var iszjmm          = false;
  // 多账户资金列表
  $scope.dzhzjlist    = [
    // {
    //   "zzh": {"hbdm":"0","hbmc":"人民币","mmpz":"","yhdm":"","yhmc":"农行存管","zcbz":"0","zjkqs":"39988334.24","zjkys":"39988334.24","zjye":"39988334.24","zjzh":"500015184","zjzhmc":"主"},
    //   "fzh": [
    //     {"hbdm":"0","hbmc":"人民币","mmpz":"","yhdm":"","yhmc":"建行存管","zcbz":"1","zjkqs":"700.00","zjkys":"700.00","zjye":"700.00","zjzh":"500015182","zjzhmc":"从"},
    //     {"hbdm":"0","hbmc":"人民币","mmpz":"","yhdm":"","yhmc":"工行存管","zcbz":"1","zjkqs":"1.00","zjkys":"1.00","zjye":"1.00","zjzh":"500015183","zjzhmc":"从"},
    //     {"hbdm":"0","hbmc":"人民币","mmpz":"","yhdm":"","yhmc":"光大存管","zcbz":"1","zjkqs":"6.00","zjkys":"6.00","zjye":"6.00","zjzh":"500015662","zjzhmc":"从"},
    //   ],
    //   "kzzje": "707.00",
    //   "index": "0",
    // }
  ];

  // 银行卡色值样式 ( 共 10 个样式, 轮循使用 )
  $scope.classNames   = ["yhk-l-bg-01","yhk-l-bg-02","yhk-l-bg-03","yhk-l-bg-04","yhk-l-bg-05","yhk-l-bg-06","yhk-l-bg-07","yhk-l-bg-08","yhk-l-bg-09","yhk-l-bg-10"];
  $scope.hblx         = ["RMB", "HKD", "USD"];

  // 索引 [0]:币种分类 [1]:该币种下的第几个
  $scope.index        = [0, 0];

	loading();

  // 提供原生回调刷新页面数据
  handlePageBack = function() {
      loading();
  }

  // 动态设置列表区域的高度
  zjgjApi.setScrollAreaHeight();

  /*===========================
    显示APP自定义键盘
  ============================*/
  $scope.showKeyboard = function(id)
  {
    showKeyboard(id,'3');
  }

	/*===========================
		页面列表数据动态加载
  ============================*/
  function loading()
  {
    $scope.dzhzjlist = [];

    // 多账户资金查询
    var postData = {
      hbdm: "",
      yhdm: "",
    };

  	ajaxPost(getApiUrl() + "ptjy/yzzz/dzhzjcx", postData, function(response)
  	{
      var cxlb = response.cxlb;
      var kzzje = response.kzzje[0];

      for (var i = 0, len = cxlb.length; i < len; i++) {
        var hbdm = cxlb[i].hbdm;
        if (hbdm == undefined || hbdm == null || hbdm == "") {
          console.log("多账户资金查询返回数据中无货币代码");
          return;
        }

        var moneyText = cxlb[i].zjkys;
        // 将资金可用数进行千分位处理
        cxlb[i]['zjkystext'] = formatNumber(moneyText);

        // 人民币
        if ("0" == hbdm && $scope.dzhzjlist[0] == undefined) {
          $scope.dzhzjlist[0] = {
            "zzh": null,
            "fzh": [],
            "kzzje": "",
            "index": "0"
          };
          $scope.dzhzjlist[hbdm].kzzje = kzzje.rmbkzzje || "";
        }
        // 港币
        else if ("1" == hbdm && $scope.dzhzjlist[1] == undefined) {
          $scope.dzhzjlist[1] = {
            "zzh": null,
            "fzh": [],
            "kzzje": "",
            "index": "1"
          };
          $scope.dzhzjlist[hbdm].kzzje = kzzje.gbkzzje || "";
        }
        // 美元
        else if ("2" == hbdm && $scope.dzhzjlist[2] == undefined) {
          $scope.dzhzjlist[2] = {
            "zzh": null,
            "fzh": [],
            "kzzje": "",
            "index": "2"
          };
          $scope.dzhzjlist[hbdm].kzzje = kzzje.mykzzje || "";
        }

        // 主资金账号
        if ("0" == cxlb[i].zcbz) {
          $scope.dzhzjlist[hbdm].zzh = cxlb[i];
        }
        // 从资金账号
        else if ("1" == cxlb[i].zcbz) {
          $scope.dzhzjlist[hbdm].fzh.push(cxlb[i]);
        }
      }

      // 删除无效元素
      for(var i = 0, len = $scope.dzhzjlist.length; i < len; i++) {
        if($scope.dzhzjlist[i] == undefined) $scope.dzhzjlist.splice(i,1);
      }
  	});
  }

  /*===========================
		功能按钮：一键归集
  ============================*/
  $scope.BtnYjgj = function(index)
  {
    console.log("BtnYjgj: index="+index);

    btn_type = 1;
    $scope.index[0] = index;

  	console.log("功能按钮：一键归集");

    var zjzh = $scope.dzhzjlist[index];

    // 主账户不存在
    if(zjzh.zzh == null) {
      showMessageTips("没有主账户");
      return;
    }

    var modal = {};
    modal['title'] = "归集确认";
    modal['single'] = [{value:"归集 " + ( formatNumber(zjzh.kzzje) || "--" ) + " 元到主账户"}];

    iszjmm = zjzh.zzh.mmpz == "2" || zjzh.zzh.mmpz == "3";

    if(iszjmm)
    {
      modal['inputbox'] = [{id:"zjmm",key:"资金密码",value:"请输入资金密码"}];
    }

    create_modal($scope, $compile, modal);
  };

  /*===========================
		功能按钮：调拨
  ============================*/
  $scope.BtnDB = function(index, index2)
  {
  	console.log("功能按钮：调拨 " + index + " " + index2);
    $scope.index = [index, index2];
    // 将多资金账户数据与选中账户的索引 ID 组合成一个 JSON
    var dataListTmp = [];
    // 主账号
    dataListTmp.push($scope.dzhzjlist[index].zzh);
    // 从账号
    dataListTmp.push($scope.dzhzjlist[index].fzh[index2]);
    // 将上面组合的 JSON 保存到本地存储中, 让下一个页面调用
    setLocalData("dataList",dataListTmp);
    // 页面跳转, 进入 "资金调度" 页面
    JumpInterface (params.viewKey.KDS_PTJY_ZJDB, 0, 1);
  };

  //====================模态框确认按钮触发事件=============================
  $scope.Ensure = function()
  {
    /*====================================================
    触发条件：[归集确认]弹框,点击确定按钮时触发事件
    执行功能：一键汇集
    ====================================================*/
    if(btn_type == 1)
    {
      var zjzh = $scope.dzhzjlist[$scope.index[0]];

      // 入参：一键汇集
      var postData = {
        hbdm  : $scope.index[0]+"",
        zjmm  : $("#zjmm").val() || ""
      };

      if( zjzh.kzzje == "" || parseFloat(zjzh.kzzje) == 0 ) {
        showMessageTips("没有可归集的总金额");
        return;
      }
      if(iszjmm && postData['zjmm'].length == 0)  {
        showMessageTips("请输入资金密码");
        return;
      }

      // 在发起请求前先关闭模态框
      CloseModal();

      ajaxPost( getApiUrl() + "ptjy/yzzz/yjhj", postData, function(response)
      {
        btn_type = 2;

        var modal = {};

        modal['title'] = "归集";
        modal['msg'] = [{ value: response.cljg[0].message }];

        create_modal($scope, $compile, modal, true);
      });

    }
    /*====================================================
    触发条件：[归集]弹框,点击确定按钮时触发事件
    执行功能：关闭弹框
    ====================================================*/
    else  if(btn_type == 2)
    {
      CloseModal();

      // 重新加载数据
      loading();
    }
  };

});


var zjgjApi = {
    // 设置表格内容区域的高度
    setScrollAreaHeight: function() {
        setTimeout(function() {
            var footer      = $("footer"),
                srcollArea  = $(".scroll-area"),
                height      = document.documentElement.clientHeight;

            footer = footer.length > 0 ? footer.height() : 0;
            height = height - srcollArea.offset().top - footer;

            srcollArea.height(height);
        }, 200);
    }
}
