var app = angular.module ("rzrqHYCHSXSZ", []);

app.controller ("rzrqHYCHSXSZController", ["$rootScope", "$scope", "$compile", "$http", function (rootScope, scope, compile, http) {
    requestData (scope);

    scope.ensureStatus = -1; // -1 初始状态  1 点击过一次确定
    scope.onCellClick = function (item) {
        scope.selectItem = item;
        var modal = {}
        modal["title"] = "合约偿还顺序设置";
        modal["longContent"] = [
            {key: '合同编号：', value: item.zqdm},
            {key: '证券名称：', value: item.zqmc},
            {key: '负债截止日期：', value: item.fzjzrq},
            {key: '合约方向/状态：', value: (item.rzrqfxsm + "/" + item.hyztsm)},
            {key: '成交金额：', value: item.cjje}
        ];
        modal["inputContent"] = [{key: "偿还顺序：", defaultValue: "0", rowId: "inputCell1"}];
        modal["explaintion"] = [{
            value: "提示：请输入0-100之间的有效数字，0表示取消设置，1表示优先级最高，100表示优先级最低。"
        }];
        setTimeout (function () {
            scope.ensureStatus = -1;
            dynGenerateNode (scope, compile, Modal, "modal", modal);
        }, 100);
    };

    scope.Ensure = function () {
        if (-1 == scope.ensureStatus) {
            var item = scope.selectItem;
            var modal = {}
            modal["title"] = "合约偿还顺序设置";
            var priority = document.getElementById ("inputCell1").value;
            scope.priority = priority;
            modal["longContent"] = [
                {key: '合同编号：', value: item.zqdm},
                {key: '证券名称：', value: item.zqmc},
                {key: '负债截止日期：', value: item.fzjzrq},
                {key: '合约方向/状态：', value: (item.rzrqfxsm + "/" + item.hyztsm)},
                {key: '成交金额：', value: item.cjje},
                {key: '偿还优先级：', value: priority}
            ];
            CloseModal ();
            setTimeout (function () {
                scope.ensureStatus = 1;
                dynGenerateNode (scope, compile, Modal, "modal", modal);
            }, 100);

        } else if (1 == scope.ensureStatus) {
            CloseModal ();
            scope.ensureStatus = -1;
            sendSureInfo (scope);
        }
    };

    scope.showKeyboard = function (id) {
        showKeyboard ("inputCell1", 1);
    };

    scope.$watch ('$viewContentLoaded', function () {
        //设置高度
        setHeight ();
    });
}]);

function setHeight () {
    // 设置表格内容区域的高度
    setTimeout (function () {
        var footer = $ ("footer"),
            srcollArea = $ (".scroll-area"),
            height = document.documentElement.clientHeight;

        footer = footer.length > 0 ? footer.height () : 0;
        height = height - srcollArea.offset ().top - footer;

        srcollArea.height (height);
    }, 200);
}

//请求数据
function requestData (scope) {
    ajaxPost (getApiUrl () + "rzrq/ptyw/hychsxcx", {}, function (response) {
        var cxlb = response.cxlb || [];
        //chyxj(偿还优先级)  zqdm(证券代码)  zqmc(证券名称)  rzrqfx(融资融券方向)  rzrqfxsm(融资融券方向说明)  cjje(成交金额)  hyzt(合约状态)  hyztsm(合约状态说明)  hybh(合约编号) fzrq(负债日期) fzjzrq(负债截止日期)
        for (var i = 0; i < cxlb.length; i++) {
            if (!cxlb[i].chyxj) {
                cxlb[i].chyxj = "0";
            }
            if (!cxlb[i].cjje) {
                cxlb[i].cjje = "0";
            }
        }
        scope.list = cxlb;
    });
};

//设置顺序
function sendSureInfo (scope) {
    var item = scope.selectItem;
    var param = {
        fzrq: item.fzrq, fzhybh: item.hybh, chyxj: scope.priority
    };
    ajaxPost (getApiUrl () + "rzrq/ptyw/hychsxsz", param, function (response) {
        requestData (scope);
    });
};


function fillInputContent(param) {
    if (param == "del") {
        var _value = $("#" + params.id).val();
        $("#" + params.id).val(_value.substring(0, _value.length - 1));
    }
    else {
        $("#" + params.id).val($("#" + params.id).val() + param);
        if (params.id == "jymm") {
            if ($("#jymm").val().length == 6) {
                bdzqDetailQuery();
            }
        }
    }
};