import React, {Component} from 'react'
// import {KmcSepline} from 'h5-dumb-lib'
import './kmc-dialog.less'

export default class KmcDialog extends Component{

    static defaultProps = {
        show: false,
        title: '',
        content: 'test',
        component: null,
        cancelText: '取消',
        okText: '确定',
    }

    state = {
        show: this.props.show,
    }

    componentWillReceiveProps(nextProps) {
        console.log("nextProps", nextProps)
        console.log("this.state.show", this.state.show)
        if(nextProps.show != this.state.show){
            this.setState({show: nextProps.show})
        }
    }

    handleOKClick(){
        console.log("点击handleOKClick")
        this.setState({show: false})
        this.props.handleOKClick && this.props.handleOKClick(this.state.choosed)
    }

    handleCancelClick(){
        console.log("点击handleCancelClick")
        this.setState({show: false})
        this.props.handleCancelClick && this.props.handleCancelClick()
    }

    render(){
        const {title, component, content, cancelText, okText} = this.props

        return  <div className="kmc kmc-dialog"
                    style={{display: this.state.show?null:'none'}}
                    >
                    <div className="dialog">
                        <div className="dialog-title">{title}</div>
                        <div className="dialog-content">
                        {this.props.children?this.props.children:
                            <p>
                                {content}
                            </p>
                        }
                        </div>
                        <div className="dialog-bottom">
                            <div className="sepline"/>
                            <div className="btn-cancel" style={{display: cancelText?null:'none'}} onClick={::this.handleCancelClick}>{cancelText}</div>
                            <div className="line" />
                            <div className="btn-ok" onClick={::this.handleOKClick}>{okText}</div>
                        </div>
                    </div>
                </div>
    }
}
